<?php

require_once("Control/DBConstants.inc");

/**
 * This class provides access to game database.
 * Implements singleton pattern.
 */
class DBManager
{	
	/**
	 * Instance of this singleton.
	 */
	private static $instance = NULL;
	
	/**
	 * DB connection or NULL.
	 */
	private $dbConnection;
	
	/**
	 * Private constructor.
	 */
	private function __construct()
	{
		$this->dbConnection = NULL;
	}	
	
	/**
	 * Disposes object.
	 * Closes connection.
	 */
	public function __destruct()
	{
		$this->Dispose();
	}

	/**
	 * Gets or creates instance of this singleton.
	 */
	public function GetInstance()
	{
		if (self::$instance == NULL)
		{
			self::$instance = new DBManager();
		}
		return self::$instance;
	}
	
	/**
	 * Disposes manager, closes connections.
	 */
	public function Dispose()
	{
		if ($this->dbConnection != NULL)
		{
			mysql_close($this->dbConnection);
			$this->dbConnection = NULL;
		}		
	}
	
	/**
	 * Connects to DB.
	 */
	private function ConnectToDB()
	{
		$this->Dispose();
		
		$this->dbConnection = mysql_connect(DBConstants::SERVER_NAME, DBConstants::USER_NAME, DBConstants::PASSWORD);
		
		if (!$this->dbConnection) 
		{
	    	$this->dbConnection = NULL;
			throw new Exception("Could not connect: " . mysql_error());
		}
		
		if (!mysql_select_db(DBConstants::DB_NAME, $this->dbConnection))
		{
			$this->dbConnection = NULL;
			throw new Exception("Could not select DB: " . mysql_error());
		}
		
		$this->PerformQuery("SET CHARACTER SET utf8");
		$this->PerformQuery("SET NAMES 'utf8';");
	}
	
	/**
	 * Performs query on DB. Returns result of query.
	 * @param query query string
	 */
	public function PerformQuery($query)
	{
		if ($this->dbConnection == NULL)
		{
			$this->ConnectToDB();
		}
		
		//echo $query . "<br />";
		//$query = mysql_real_escape_string($query, $this->dbConnection);
		
		$result = mysql_query($query, $this->dbConnection);

		if (!$result)
		{
			throw new Exception("Invalid query: " . mysql_error());
		}
		
		return $result;
	}
	
	/**
	 * Performs query on DB. Returns result of query as associative array.
	 * @param query query string
	 */
	public function PerformQueryAssoc($query)
	{
		if ($this->dbConnection == NULL)
		{
			$this->ConnectToDB();
		}
		
		$result = $this->PerformQuery($query);	
		try 
		{
			return mysql_fetch_assoc($result);
		}
		catch (Exception $e)
		{
			throw new Exception("Error fetchind data from DB: ".$e->getMessage());
		}
	}
	
	public function GetLastId()
	{
		if ($this->dbConnection == NULL)
		{
			return -1;
		}
		
		return mysql_insert_id($this->dbConnection);
	}
	
	//CODE FROM WWW.GREGGDEV.COM
	public function ReadRandomRow($tableName, $idName) 
	{
		$max_sql = "SELECT max(".$idName.") AS max_id FROM " . $tableName;
		$max_row = $this->PerformQueryAssoc($max_sql);
      	$random_number = mt_rand(1, $max_row['max_id']);
      	
      	$random_sql = "SELECT * FROM " . $tableName . " WHERE " . $idName . " >= " . $random_number . " ORDER BY " . $idName . " ASC LIMIT 1";
		$random_row = $this->PerformQueryAssoc($random_sql);

      	if (!is_array($random_row)) 
      	{
			$random_sql = "SELECT * FROM " . $tableName . " WHERE " . $idName . " < " . $random_number . " ORDER BY " . $idName . " ASC LIMIT 1";
			$random_row = $this->PerformQueryAssoc($random_sql);
      	}
      	
		return $random_row;
	}
}

?>