<?php

require_once("Model/DictionaryRecord.inc");
require_once("Control/Globals.inc");

class Dictionary
{
	private static $instance = NULL;
	
	private $dictionary;

	private function __construct()
	{
		$this->dictionary = array();
	}
	
	public function GetInstance()
	{
		if (self::$instance == NULL)
		{
			self::$instance = new Dictionary();
		}
		
		return self::$instance;
	}
	
	public function Translate($nameOfTerm, $languageCode = -1)
	{
		if ($nameOfTerm == NULL)
		{
			return "NO TERM";
		}
		
		if ($languageCode < 0)
		{
			$languageCode = Globals::GetLanguage();
		}	
		
		if (array_key_exists($nameOfTerm, $this->dictionary))
		{
			$record = $this->dictionary[$nameOfTerm];
			if ($record->GetLanguage() == $languageCode)
			{
				return $record->GetTranslation();
			}
		}
		
		$record = DictionaryRecord::LoadFromDB($nameOfTerm, $languageCode);
		
		if ($record == NULL)
		{
			return ">>".$nameOfTerm."<<";
		}
		
		$this->dictionary[$record->GetName()] = $record;
		return $record->GetTranslation();
	}  
}

?>