<?php

require_once('Control/Utils.inc');
require_once('Model/Player.inc');
require_once('Model/Ship.inc');

/**
 * Static class with gameplay constants.
 */
class GameConstants
{
	const LIMIT_FOR_DELIVERY_REFILL = 3;
	const OPTIMAL_DELIVERIES_PER_PLANET = 10;
	const DELIVERY_LOCAL_RATIO = 0.5;
	const MAX_DOCK_DISTANCE = 140000000; // toleranci na pristani bych z tohoto duvodu nastavil zatim na 140tis km
	const MIN_CARGO_AMOUNT = 1;
	const MAX_CARGO_AMOUNT = 10;
	const PRICE_FOR_DIRECTION_CHANGE = 50;
	const PIRATE_RELATION_REDUCTION_PLAYER_RATIO = 0.25;
	const PIRATE_ATTACK_FLEET_PROBABILITY = 0.25;
	const PIRATE_ATTACK_ADVANTAGE_RATIO = 1.25;
	const PIRATE_UPDATE_PERIOD_REAL_SEC = 24000;
	const NPC_BLOCK_HANDICAP = 5;
	
	const GAME_NAME = "KIV-webgame"; 
	const GAME_URL = "http://students.kiv.zcu.cz/projekty/webgame/iter4";
	
	const REGISTRATION_ACTIVATION_LIFETIME = 86400;
	const ALLIANCE_INVITATION_EXPIRATION = 172800;
	
	const BASE_PRICE = 50000;
	const BASE_BUILT_TIME = 20; // in game days
	const DOCK_PRICE = 2500;
	const LICENCE_PRICE_BASE = 10000;
	const EMBASSY_PRICE_BASE = 10000;
	const ALLIANCE_MONEY_DONATE_MAX = 10000;
	const WORMHOLE_TAXES_FROM_CARGO_RATIO = 0.05;
	
	const POINTS_FOR_BASE = 5;
	const CARGO_SHIP_TYPE_ID = 1;
	const GUARD_SHIP_TYPE_ID = 2;
	const CARGO_SHIP_TYPE_MAX_LEVEL = 5;
	
	const TIME_TO_PLAYER_DELETE = 86400;
	
	public static function GetLicencePrice(Player $player)
	{
		return self::LICENCE_PRICE_BASE * Utils::GetFibbonaci($player->GetLicenceCount() + 1);
	}
	
	public static function GetShipLevelPrice(Ship $ship)
	{
		return round($ship->GetModel()->GetPrice() * ($ship->GetLevel() + 1) / 2.0); 
	}
	
	public static function GetEmbassyLevelPrice(Player $player)
	{
		return self::EMBASSY_PRICE_BASE * Utils::GetFibbonaci($player->GetEmbassyLevel() + 1);
	}
	
	public static function IsShipLevelable(Ship $ship)
	{
		return $ship->GetModel()->GetShipType()->GetId() == self::CARGO_SHIP_TYPE_ID;
	}
	
	public static function GetShipPointValue(Ship $ship)
	{
		$points = $ship->GetModel()->GetShipType()->GetPointValue();
		if ($ship->GetModel()->GetShipType()->GetId() == self::CARGO_SHIP_TYPE_ID)
		{
			$points *= $ship->GetLevel();
		}
		
		return $points;
	}
}

?>