<?php

require_once("Control/DBManager.inc");
require_once("Control/DBConstants.inc");

class ActionLogRecord
{
	/**
	 * ID of good type in DB.
	 */
	private $id;
	
	/**
	 * Gets ID of good type in DB.
	 */
	public function GetId()
	{
		return $this->id;		
	}
		
	private $playerId;
	
	public function GetPlayerId()
	{
		return $this->playerId;
	}
	
	private $typeId;
	
	public function GetTypeId()
	{
		return $this->typeId;
	}
	
	private $args;
	
	public function GetArgs()
	{
		return $this->args;
	}
		
	private $date;
	
	public function GetDate()
	{
		return $this->date;
	}
		
	/**
	 * Creates new instance with specified ID.
	 * @param id ID of new instance
	 */
	private function __construct($id)
	{
		if ($id <= 0)
		{
			throw new Exception("Ivalid ID value.");			
		}
		
		$this->id = $id;
	}
	
	/**
	 * Loads from DB using ID.
	 * @param id ID of good in DB
	 */
	public static function LoadFromDB($id)
	{
		if ($id <= 0)
		{
			throw new Exception("Ivalid ID value.");			
		}
		
		$dbManager = DBManager::GetInstance();

		$query = sprintf("SELECT * FROM `%s` WHERE id=%d", DBConstants::ACTION_LOG_TABLE_NAME, $id);
		$data = $dbManager->PerformQueryAssoc($query);
		
		if (!$data)
		{
			return NULL;
		}
		
		$record = new ActionLogRecord($data["id"]);
		
		$record->playerId = $data["player_id"];
		$record->typeId = $data["type_id"];
		$record->args = $data["args"];
		$record->date = $data["date"];
		
		return $record;
	}
	
	public static function CreateNewRecord($playerId, $typeId, $args, $time = -1)
	{
		if ($time < 0)
		{
			$time = time();
		}
		
		$dbManager = DBManager::GetInstance();

		$query = sprintf("INSERT INTO `%s` (player_id, type_id, args, date) ", DBConstants::ACTION_LOG_TABLE_NAME);
		$query .= sprintf("VALUES (%d, %d, '%s', %d)", $playerId, $typeId, $args, $time);
		
		$dbManager->PerformQuery($query);
		
		$id = mysql_insert_id();
		
		if ($id <= 0)
		{
			return NULL;
		}
		
		return ActionLogRecord::LoadFromDB($id);
	}
	
	public function RemoveFromDB()
	{
		$dbManager = DBManager::GetInstance();

		$query = sprintf("DELETE FROM `%s` WHERE id=%d", DBConstants::ACTION_LOG_TABLE_NAME, $this->id);
		$data = $dbManager->PerformQuery($query);
		
		//echo "mazu ". $this->GetId() ."<br/>";
		
		return true;
	}
	
	public static function RemoveFromDBAllForPlayer($playerId)
	{
		$dbManager = DBManager::GetInstance();

		$query = sprintf("DELETE FROM `%s` WHERE player_id=%d", DBConstants::ACTION_LOG_TABLE_NAME, $playerId);
		$data = $dbManager->PerformQuery($query);
		
		//echo "mazu ". $this->GetId() ."<br/>";
		
		return true;
	}
}

?>