<?php

require_once("Control/DBManager.inc");
require_once("Control/DBConstants.inc");
require_once("Model/Player.inc");

class AllianceInvitation
{
	/**
	 * ID of good type in DB.
	 */
	private $id;
	
	/**
	 * Gets ID of good type in DB.
	 */
	public function GetId()
	{
		return $this->id;		
	}
		
	private $invitedId;
	
	public function GetInvitedId()
	{
		return $this->invitedId;
	}
		
	private $allianceId;
	
	public function GetAllianceId()
	{
		return $this->allianceId;
	}
	
	private $senderId;
	
	public function GetSenderId()
	{
		return $this->senderId;
	}
	
	private $time;
	
	public function GetTime()
	{
		return $this->time;
	}
			
	/**
	 * Creates new instance with specified ID.
	 * @param id ID of new instance
	 */
	private function __construct($id)
	{
		if ($id <= 0)
		{
			throw new Exception("Ivalid ID value.");			
		}
		
		$this->id = $id;
	}
	
	/**
	 * Loads from DB using ID.
	 * @param id ID of good in DB
	 */
	public static function LoadFromDB($id)
	{
		if ($id <= 0)
		{
			throw new Exception("Ivalid ID value.");			
		}
		
		$dbManager = DBManager::GetInstance();

		$query = sprintf("SELECT * FROM `%s` WHERE id=%d", DBConstants::ALLIANCE_INVITATION_TABLE_NAME, $id);
		$data = $dbManager->PerformQueryAssoc($query);
		
		if (!$data)
		{
			return NULL;
		}
		
		$invitation = new AllianceInvitation($data["id"]);
		$invitation->invitedId = $data["invited_id"];
		$invitation->allianceId = $data["alliance_id"];
		$invitation->senderId = $data["sender_id"];
		$invitation->time = $data["time"];
		
		return $invitation;
	}
	
	public static function LoadFromDBForInvitedAndAlliance($invitedId, $allianceId)
	{
		$dbManager = DBManager::GetInstance();

		$query = sprintf("SELECT id FROM `%s` WHERE invited_id=%d AND alliance_id=%d", 
			DBConstants::ALLIANCE_INVITATION_TABLE_NAME, $invitedId, $allianceId);
		$data = $dbManager->PerformQueryAssoc($query);
		
		if (!$data)
		{
			return NULL;
		}
		
		return AllianceInvitation::LoadFromDB($data["id"]);
	}
	
	public static function CreateNew($allianceId, $senderId, $invitedId)
	{
		$dbManager = DBManager::GetInstance();

		$query = sprintf("INSERT INTO `%s` (alliance_id, sender_id, invited_id, time) ", DBConstants::ALLIANCE_INVITATION_TABLE_NAME);
		$query .= sprintf("VALUES (%d, %d, %d, %d)", $allianceId, $senderId, $invitedId, time());
				
		$dbManager->PerformQuery($query);
		
		$id = mysql_insert_id();
		
		if ($id <= 0)
		{
			return NULL;
		}
		
		return AllianceInvitation::LoadFromDB($id);
	}
	
	public function RemoveFromDB()
	{
		$dbManager = DBManager::GetInstance();

		$query = sprintf("DELETE FROM `%s` WHERE id=%d", DBConstants::ALLIANCE_INVITATION_TABLE_NAME, $this->id);
		$dbManager->PerformQuery($query);
		
		return 1;
	}
}

?>