<?php

require_once("Control/DBManager.inc");
require_once("Control/DBConstants.inc");

class Base
{
	/**
	 * ID of good type in DB.
	 */
	private $id;
	
	/**
	 * Gets ID of good type in DB.
	 */
	public function GetId()
	{
		return $this->id;		
	}
		
	private $playerId;
	
	public function GetPlayerId()
	{
		return $this->playerId;
	}
	
	private $planetId;
	
	public function GetPlanetId()
	{
		return $this->planetId;
	}
	
	private $builtTime;
	
	public function GetBuiltTime()
	{
		return $this->builtTime;
	}
	
	/**
	 * Creates new instance with specified ID.
	 * @param id ID of new instance
	 */
	private function __construct($id)
	{
		if ($id <= 0)
		{
			throw new Exception("Ivalid ID value.");			
		}
		
		$this->id = $id;
	}
	
	/**
	 * Loads from DB using ID.
	 * @param id ID of good in DB
	 */
	public static function LoadFromDB($id)
	{
		if ($id <= 0)
		{
			throw new Exception("Ivalid ID value.");			
		}
		
		$dbManager = DBManager::GetInstance();

		$query = sprintf("SELECT * FROM `%s` WHERE id=%d", DBConstants::BASE_TABLE_NAME, $id);
		$data = $dbManager->PerformQueryAssoc($query);
		
		if (!$data)
		{
			return NULL;
		}
		
		$base = new Base($data["id"]);
		
		$base->playerId = $data["player_id"];
		$base->planetId = $data["planet_id"];
		$base->builtTime = $data["built_time"];
		
		return $base;
	}
	
	public static function CreateNewBase($playerId, $planetId, $builtTime)
	{
		$dbManager = DBManager::GetInstance();

		$query = sprintf("INSERT INTO `%s` (player_id, planet_id, built_time) ", DBConstants::BASE_TABLE_NAME);
		$query .= sprintf("VALUES (%d, %d, %d)", $playerId, $planetId, $builtTime);
		
		$dbManager->PerformQuery($query);
		
		$id = mysql_insert_id();
		
		if ($id <= 0)
		{
			return NULL;
		}
		
		return Base::LoadFromDB($id);
	}
}

?>