<?php

require_once("Control/DBManager.inc");
require_once("Control/DBConstants.inc");
require_once("Control/Globals.inc");

/**
 * Class represents one record in dictionary.
 * Image of database entity "".
 */
class DictionaryRecord
{	
	private $name;
	
	public function GetName()
	{
		return $this->name;
	}
	
	private $translation;
	
	public function GetTranslation()
	{
		return $this->translation;
	}
	
	private $language;
	
	public function GetLanguage()
	{
		return $this->language;
	}
	
	private function __construct($name)
	{
		if ($name == NULL)
		{
			throw new Exception("Name must be provided.");
		}
		
		$this->name = $name;
	}
	
	public static function LoadFromDB($name, $languageCode)
	{
		if ($name == NULL)
		{
			throw new Exception("Name of term must be provided.");	
		}
		
		if ($languageCode < 0)
		{
			$languageCode = Globals::GetLanguage();
		} 
		else if ($languageCode >= Globals::LANG_COUNT)
		{
			throw new Exception("Invalid language code.");
		}
		
		switch ($languageCode)
		{
			case Globals::LANG_CS_CZ:
				$domain = "cs";
				break;
			case Globals::LANG_EN_UK:
				$domain = "en";
				break;
			default:
				$domain = "cs";
				break;				
		}
		
		$dbManager = DBManager::GetInstance();

		$query = sprintf("SELECT `%s` FROM `%s` WHERE `default`='%s'", $domain, DBConstants::DICTIONARY_TABLE_NAME, $name);
		$data = $dbManager->PerformQueryAssoc($query);
		
		if (!$data)
		{
			return NULL;
		}	

		$record = new DictionaryRecord($name);
		$record->translation = $data[$domain];
		$record->language = $languageCode;
		
		return $record;
	}
}

?>