<?php

require_once("Control/DBManager.inc");
require_once("Control/DBConstants.inc");

/**
 * Describes type of stuff to deliver as stored in DB.
 * Image of DB entity "zbozi".
 */
class GoodType
{
	/**
	 * ID of good type in DB.
	 */
	private $id;
	
	/**
	 * Gets ID of good type in DB.
	 */
	public function GetId()
	{
		return $this->id;		
	}
	
	/**
	 * Name of good.
	 */
	private $name;
	
	/**
	 * Gets name of good type.
	 */
	public function GetName()
	{
		return $this->name;
	}
	
	/**
	 * Basic amount of money earned by transfering 1 amount of good 
	 * on distance of 1 lenght unit.
	 */
	private $basicRevenue;
	
	/**
	 * Gets basic amount of money earned by transfering 1 amount of good 
	 * on distance of 1 lenght unit.
	 */
	public function GetBasicRevenue()
	{
		return $this->basicRevenue;
	}
	
	/**
	 * Hell knows what parameters.
	 */
	private $sysparam;
	
	private $goodClass;
	
	public function GetGoodClass()
	{
		return $this->goodClass;	
	}
	
	/**
	 * Creates new instance with specified ID.
	 * @param id ID of new instance
	 */
	private function __construct($id)
	{
		if ($id <= 0)
		{
			throw new Exception("Ivalid ID value.");			
		}
		
		$this->id = $id;
	}
	
	/**
	 * Loads from DB using ID.
	 * @param id ID of good in DB
	 */
	public static function LoadFromDB($id)
	{
		if ($id <= 0)
		{
			throw new Exception("Ivalid ID value.");			
		}
		
		$dbManager = DBManager::GetInstance();

		$query = sprintf("SELECT * FROM `%s` WHERE id=%d", DBConstants::GOODS_TABLE_NAME, $id);
		$data = $dbManager->PerformQueryAssoc($query);
		
		if (!$data)
		{
			return NULL;
		}
		
		$goodType = new GoodType((int)$data["ID"]);
		
		$goodType->name = $data["nazev"];
		$goodType->sysparam = $data["sysparam"];
		$goodType->basicRevenue = $data["zakl_cena"];
		$goodType->goodClass = GoodClass::LoadFromDB($data["ClassId"]);
		
		return $goodType;
	}
	
	/**
	 * Loads all good types from DB and returns them
	 * as array with IDs as keys.
	 * @return array of goods with IDs as keys
	 */
	public static function LoadAllFromDB()
	{
		$dbManager = DBManager::GetInstance();

		$query = sprintf("SELECT ID FROM `%s`", DBConstants::GOODS_TABLE_NAME);
		$rows = $dbManager->PerformQuery($query);
		
		if (!$rows)
		{
			return NULL;
		}
		
		$goods = array();
		while ($row = mysql_fetch_assoc($rows))
		{
			
			$goodType = GoodType::LoadFromDB($row["ID"]);	
			$goods[$goodType->GetId()] = $goodType;
		}
		
		return $goods;
	}
}

?>