<?php

require_once("Control/DBManager.inc");
require_once("Control/DBConstants.inc");

class Message
{
	/**
	 * ID of good type in DB.
	 */
	private $id;
	
	/**
	 * Gets ID of good type in DB.
	 */
	public function GetId()
	{
		return $this->id;		
	}
		
	private $senderId;
	
	public function GetSenderId()
	{
		return $this->senderId;
	}
	
	private $recieverId;
	
	public function GetRecieverId()
	{
		return $this->recieverId;
	}
	
	private $subject;
	
	public function GetSubject()
	{
		return $this->subject;
	}
	
	private $text;
	
	public function GetText()
	{
		return $this->text;
	}
	
	private $sentTime;
	
	public function GetSentTime()
	{
		return $this->sentTime;
	}
	
	private $readTime;
	
	public function WasRead()
	{
		if ($this->readTime == NULL)
		{
			return false;
		}
		
		return true;
	}
	
	public function MarkRead()
	{
		if ($this->readTime != NULL)
		{
			return;
		}
		
		$time = time();
		
		$dbManager = DBManager::GetInstance();

		$query = sprintf("UPDATE `%s` SET read_time=%d WHERE ID=%d", DBConstants::MESSAGE_TABLE_NAME, $time, $this->id);
		$data = $dbManager->PerformQuery($query);
		
		$this->readTime = $time;		
		return true;
	}
	
	/**
	 * Creates new instance with specified ID.
	 * @param id ID of new instance
	 */
	private function __construct($id)
	{
		if ($id <= 0)
		{
			throw new Exception("Ivalid ID value.");			
		}
		
		$this->id = $id;
	}
	
	/**
	 * Loads from DB using ID.
	 * @param id ID of good in DB
	 */
	public static function LoadFromDB($id)
	{
		if ($id <= 0)
		{
			throw new Exception("Ivalid ID value.");			
		}
		
		$dbManager = DBManager::GetInstance();

		$query = sprintf("SELECT * FROM `%s` WHERE id=%d", DBConstants::MESSAGE_TABLE_NAME, $id);
		$data = $dbManager->PerformQueryAssoc($query);
		
		if (!$data)
		{
			return NULL;
		}
		
		$message = new Message($data["id"]);
		
		$message->senderId = $data["sender_id"];
		$message->recieverId = $data["reciever_id"];
		$message->subject = $data["subject"];
		$message->text = $data["text"];
		$message->sentTime = $data["sent_time"];
		$message->readTime = $data["read_time"];
		
		return $message;
	}
	
	public static function CreateNewMessage($senderId, $recieverId, $subject, $text)
	{
		
		$dbManager = DBManager::GetInstance();

		$query = sprintf("INSERT INTO `%s` (sender_id, reciever_id, subject, text, sent_time) ", DBConstants::MESSAGE_TABLE_NAME);
		$query .= sprintf("VALUES (%d, %d, '%s', '%s', %d)", $senderId, $recieverId, $subject, $text, time());
		
		$dbManager->PerformQuery($query);
		
		$id = mysql_insert_id();
		
		if ($id <= 0)
		{
			return NULL;
		}
		
		return Message::LoadFromDB($id);
	}
	
	public function RemoveFromDB()
	{
		$dbManager = DBManager::GetInstance();

		$query = sprintf("DELETE FROM `%s` WHERE id=%d", DBConstants::MESSAGE_TABLE_NAME, $this->id);
		$data = $dbManager->PerformQuery($query);
		
		//echo "mazu ". $this->GetId() ."<br/>";
		
		return true;
	}
}

?>