<?php

require_once("Control/DBManager.inc");
require_once("Control/DBConstants.inc");
require_once("Model/Ship.inc");
require_once("Model/Message.inc");
require_once("Model/Base.inc");
require_once("Model/ActionLogRecord.inc");

/**
 * Class represents game player.
 * Image of database entity "hraci".
 */
class Player
{
	const MIN_LOGIN_LENGTH = 5;
	const MAX_LOGIN_LENGTH = 30;
	const MIN_PASSWORD_LENGTH = 5;
	const MAX_PASSWORD_LENGTH = 32;
	
	/**
	 * ID of player as in DB.
	 */
	private $id;
	 
	/**
	 * Gets ID of player as in DB.
	 */
	public function GetId()
	{
		return $this->id;		
	}
	
	private $login;
	
	public function GetLogin()
	{
		return $this->login;		
	}
	
	private $email;
	
	public function GetEmail()
	{
		return $this->email;		
	}
	
	public function SetEmail($email)
	{
		$dbManager = DBManager::GetInstance();

		$query = sprintf("UPDATE `%s` SET email='%s' WHERE ID=%d", DBConstants::PLAYER_TABLE_NAME, $email, $this->id);
		$data = $dbManager->PerformQuery($query);
		
		$this->email = $email;		
		return true;
	}
	
	private $nick;
	
	public function GetNick()
	{
		return $this->nick;		
	}
	
	public function SetNick($nick)
	{
		$dbManager = DBManager::GetInstance();

		$query = sprintf("UPDATE `%s` SET nick='%s' WHERE ID=%d", DBConstants::PLAYER_TABLE_NAME, $nick, $this->id);
		$data = $dbManager->PerformQuery($query);
		
		$this->nick = $nick;		
		return true;
	}
	
	public function GetStringIdentifier()
	{
		if ($this->nick == NULL || strlen($this->nick) == 0)
		{
			return $this->login;
		}
		
		return $this->nick;
	}
	
	private $passwordHash;
	
	public function GetPasswordHash()
	{
		return $this->passwordHash;		
	}
	
	public function SetPasswordHash($passwordHash)
	{
		$dbManager = DBManager::GetInstance();

		$query = sprintf("UPDATE `%s` SET heslo='%s' WHERE ID=%d", DBConstants::PLAYER_TABLE_NAME, $passwordHash, $this->id);
		$data = $dbManager->PerformQuery($query);
		
		$this->passwordHash = $passwordHash;		
		return true;
	}
	
	private $address;
	
	public function GetAddress()
	{
		return $this->address;		
	}
	
	public function SetAddress($address)
	{
		$dbManager = DBManager::GetInstance();

		$query = sprintf("UPDATE `%s` SET address='%s' WHERE ID=%d", DBConstants::PLAYER_TABLE_NAME, $address, $this->id);
		$data = $dbManager->PerformQuery($query);
		
		$this->address = $address;		
		return true;
	}
	
	private $age;
	
	public function GetAge()
	{
		return $this->age;		
	}
	
	public function SetAge($age)
	{
		$dbManager = DBManager::GetInstance();

		$query = sprintf("UPDATE `%s` SET age=%d WHERE ID=%d", DBConstants::PLAYER_TABLE_NAME, $age, $this->id);
		$data = $dbManager->PerformQuery($query);
		
		$this->age = $age;		
		return true;
	}
	
	private $language;
	
	public function GetLanguage()
	{
		return $this->language;		
	}
	
	public function SetLanguage($language)
	{
		$dbManager = DBManager::GetInstance();

		$query = sprintf("UPDATE `%s` SET language=%d WHERE ID=%d", DBConstants::PLAYER_TABLE_NAME, $language, $this->id);
		$data = $dbManager->PerformQuery($query);
		
		$this->language = $language;		
		return true;
	}
	
	private $money;
	
	public function GetMoney()
	{
		return $this->money;
	}
	
	public function WriteNewMoney($value)
	{
		$dbManager = DBManager::GetInstance();

		$query = sprintf("UPDATE `%s` SET penize=%d WHERE ID=%d", DBConstants::PLAYER_TABLE_NAME, $value, $this->id);
		$data = $dbManager->PerformQuery($query);
		
		$this->money = $value;		
		return true;
	}
	
	private $licenceCount;
	
	public function GetLicenceCount()
	{
		return $this->licenceCount;
	}
	
	public function SetLicenceCount($value)
	{
		$dbManager = DBManager::GetInstance();

		$query = sprintf("UPDATE `%s` SET licence_count=%d WHERE ID=%d", DBConstants::PLAYER_TABLE_NAME, $value, $this->id);
		$data = $dbManager->PerformQuery($query);
		
		$this->licenceCount = $value;		
		return true;
	}
	
	private $points;
	private $lastLoginTime;
	
	public function NoticeLoginTime()
	{
		$dbManager = DBManager::GetInstance();
		
		$time = time();

		$query = sprintf("UPDATE `%s` SET lastlogin=%d WHERE ID=%d", DBConstants::PLAYER_TABLE_NAME, $time, $this->id);
		$data = $dbManager->PerformQuery($query);
		
		$this->lastLoginTime = $time;
		return true;
	}
	
	private $lastAction;
	
	public function GetLastAction()
	{
		return $this->lastAction;
	}
	
	public function MarkLastAction()
	{
		$dbManager = DBManager::GetInstance();
		
		$time = time();

		$query = sprintf("UPDATE `%s` SET lastaction=%d WHERE ID=%d", DBConstants::PLAYER_TABLE_NAME, $time, $this->id);
		$data = $dbManager->PerformQuery($query);
		
		$this->lastAction = $time;
		return true;
	}
	
	public function PerformNewAction($action)
	{
		$dbManager = DBManager::GetInstance();

		$query = sprintf("UPDATE `%s` SET lastaction='%s' WHERE ID=%d", DBConstants::PLAYER_TABLE_NAME, $action, $this->id);
		$data = $dbManager->PerformQuery($query);
		
		$this->lastAction = $action;
		
		return true;
	}
	
	private $homePlanetId;
	
	public function GetHomePlanetId()
	{
		return $this->homePlanetId;
	}
	
	private $pirateRelations;
	
	public function GetPirateRelations()
	{
		return $this->pirateRelations;
	}
	
	public function SetPirateRelations($relations)
	{
		$dbManager = DBManager::GetInstance();

		$query = sprintf("UPDATE `%s` SET pirate_relations='%d' WHERE ID=%d", DBConstants::PLAYER_TABLE_NAME, $relations, $this->id);
		$data = $dbManager->PerformQuery($query);
		
		$this->pirateRelations = $relations;
		
		return true;
	}
	
	private $embassyLevel;
	
	public function GetEmbassyLevel()
	{
		return $this->embassyLevel;
	}
	
	public function SetEmbassyLevel($level)
	{
		$dbManager = DBManager::GetInstance();

		$query = sprintf("UPDATE `%s` SET embassy_level='%d' WHERE ID=%d", DBConstants::PLAYER_TABLE_NAME, $level, $this->id);
		$data = $dbManager->PerformQuery($query);
		
		$this->embassyLevel = $level;
		
		return true;
	}
	
	private $allianceId;
	
	public function GetAllianceId()
	{
		return $this->allianceId;
	}
	
	public function SetAllianceId($id)
	{
		$dbManager = DBManager::GetInstance();
		
		$idString = $id == NULL ? "NULL" : "" . $id;
		$query = sprintf("UPDATE `%s` SET alliance_id=%s WHERE ID=%d", DBConstants::PLAYER_TABLE_NAME, $idString, $this->id);
		$data = $dbManager->PerformQuery($query);
		
		$this->allianceId = $id;
		
		return true;
	}
	
	private $flags;
	
	public function IsPCPlayer()
	{
		return $this->HasFlag("sd");
	}
	
	public function IsPirate()
	{
		return $this->HasFlag("pirates");
	}
	
	public function IsActive()
	{
		return $this->HasFlag("active");
	}
	
	public function SetActive($active)
	{
		$this->SetFlag("active", $active);
	}
	
	public function HasFlag($flag)
	{
		return !(strpos($this->flags, $flag) === false);
	}
	
	public function GetFlagValues($flag)
	{
		if (!$this->HasFlag($flag))
		{
			return NULL;
		}
		
		$pos = strpos($this->flags, $flag);
		$flag = split(";", substr($this->flags, $pos));
		$flag = $flag[0];
		$values = split("%", $flag);
		return $values;
	}
	
	public function SetFlag($flag, $enable, $values = array())
	{
		if ($enable == $this->HasFlag($flag))
		{
			return;	
		}
		
		if ($enable)
		{
			$flags = $this->flags.";".$flag;	
			
			foreach ($values as $value)
			{
				$flags .= "%" . $value;
			}
		} 
		else 
		{	
			$tokens = split(";", $this->flags);
			$flags = "";
			
			foreach ($tokens as $token)
			{
				if (strlen($token) == 0 || strpos($token, $flag) === 0)
				{
					continue;
				}
				
				$flags .= ";" . $token;
			}
		}
		
		$trans = array(";;" => ";");
		$flags = strtr($flags, $trans);	
				
		$dbManager = DBManager::GetInstance();

		$query = sprintf("UPDATE `%s` SET flags='%s' WHERE ID=%d", DBConstants::PLAYER_TABLE_NAME, $flags, $this->id);
		$data = $dbManager->PerformQuery($query);
		
		$this->flags = $flags;
	}
	
	private $ships;
	
	/**
	 * Gets array of player's ships with their IDs as keys.
	 * May return null if not loaded yet - it is loaded separately
	 * to save performance when no ships are needed - i.e. when just
	 * retrieving account state.
	 */
	public function GetShips()
	{
		return $this->ships;
	}
	
	/**
	 * Gets ships for player.
	 * Reads from DB if necessary.
	 * @return ships for player
	 */
	public function GetShipsForced()
	{
		if ($this->ships == NULL)
		{
			$this->LoadShipsFromDB();
		}
		
		return $this->ships;
	}
	
	private $bases;
	
	/**
	 * Gets array of player's bases with their IDs as keys.
	 * May return null if not loaded yet - it is loaded separately
	 * to save performance when no ships are needed - i.e. when just
	 * retrieving account state.
	 */
	public function GetBases()
	{
		return $this->bases;
	}
	
	/**
	 * Gets bases for player.
	 * Reads from DB if necessary.
	 * @return bases for player
	 */
	public function GetBasesForced()
	{
		if ($this->bases == NULL)
		{
			$this->LoadBasesFromDB();
		}
		
		return $this->bases;
	}
	
	private $messages;
	
	/**
	 * Gets array of player's messages with their IDs as keys.
	 * May return null if not loaded yet - it is loaded separately
	 * to save performance when no ships are needed - i.e. when just
	 * retrieving account state.
	 */
	public function GetMessages()
	{
		return $this->messages;
	}
	
	/**
	 * Gets messages for player.
	 * Reads from DB if necessary.
	 * @return bases for player
	 */
	public function GetMessagesForced()
	{
		if ($this->messages == NULL)
		{
			$this->LoadMessagesFromDB();
		}
		
		return $this->messages;
	}
	
	private $allianceInvitations;
	
	/**
	 * Gets array of player's messages with their IDs as keys.
	 * May return null if not loaded yet - it is loaded separately
	 * to save performance when no ships are needed - i.e. when just
	 * retrieving account state.
	 */
	public function GetAllianceInvitations()
	{
		return $this->allianceInvitations;
	}
	
	/**
	 * Gets messages for player.
	 * Reads from DB if necessary.
	 * @return bases for player
	 */
	public function GetAllianceInvitationsForced()
	{
		if ($this->allianceInvitations == NULL)
		{
			$this->LoadAllianceInvitationsFromDB();
		}
		
		return $this->allianceInvitations;
	}
	
	private function __construct($id) 
	{ 
		$this->id = $id;
		$this->ships = NULL;
		$this->bases = NULL;
		$this->messages = NULL;	
	}
	
	public static function LoadAllFromDB()
	{
		$dbManager = DBManager::GetInstance();

		$query = sprintf("SELECT ID FROM `%s`", DBConstants::PLAYER_TABLE_NAME);
		$rows = $dbManager->PerformQuery($query);
		
		if (!$rows)
		{
			return NULL;
		}
		
		$players = array();
		
		while ($row = mysql_fetch_assoc($rows))
		{
			$player = Player::LoadFromDB($row["ID"]);	
			$players[$player->GetId()] = $player;
		}
		
		return $players;
	}
	
	/**
	 * Loads player and his ships from DB.
	 * @param $id id of player in DB
	 * @return void
	 */
	public static function LoadFromDB($id)
	{
		if ($id <= 0)
		{
			throw new Exception("Id must be positive integer.");
		}
		
		$dbManager = DBManager::GetInstance();

		$query = sprintf("SELECT * FROM `%s` WHERE ID=%d", DBConstants::PLAYER_TABLE_NAME, $id);
		$data = $dbManager->PerformQueryAssoc($query);
		
		if (!$data)
		{
			return NULL;
		}
		
		return Player::ParseFromDBRow($data);		
	}
	
	public static function LoadFromDBByLogin($login)
	{
		if ($login == NULL)
		{
			throw new Exception("Player login must be provided.");
		}
		
		$dbManager = DBManager::GetInstance();

		$query = sprintf("SELECT * FROM `%s` WHERE login='%s'", DBConstants::PLAYER_TABLE_NAME, $login);
		$data = $dbManager->PerformQueryAssoc($query);
		
		if (!$data)
		{
			return NULL;
		}
		
		return Player::ParseFromDBRow($data);	
	}
	
	public static function LoadPCPlayerFromDB()
	{
		$dbManager = DBManager::GetInstance();

		$query = sprintf("SELECT * FROM `%s` WHERE flags LIKE '%%sd%%'", DBConstants::PLAYER_TABLE_NAME);
		$data = $dbManager->PerformQueryAssoc($query);
		
		if (!$data)
		{
			return NULL;
		}
		
		return Player::ParseFromDBRow($data);	
	}
	
	public static function LoadPiratesFromDB()
	{
		$dbManager = DBManager::GetInstance();

		$query = sprintf("SELECT * FROM `%s` WHERE flags LIKE '%%pirates%%'", DBConstants::PLAYER_TABLE_NAME);
		$data = $dbManager->PerformQueryAssoc($query);
		
		if (!$data)
		{
			return NULL;
		}
		
		return Player::ParseFromDBRow($data);	
	}
	
	private static function ParseFromDBRow(array $row)
	{
		$player = new Player($row["ID"]);
		$player->login = $row["login"];
		$player->email = $row["email"];
		$player->nick = $row["nick"];
		$player->passwordHash = $row["heslo"];
		$player->money = $row["penize"];
		$player->points = $row["body"];
		$player->lastAction = $row["lastaction"];
		$player->flags = $row["flags"];
		$player->address = $row["address"];
		$player->age = $row["age"];
		$player->language = $row["language"];
		$player->homePlanetId = $row["home_planet"];
		$player->licenceCount = $row["licence_count"];
		$player->pirateRelations = $row["pirate_relations"];
		$player->embassyLevel = $row["embassy_level"];
		$player->allianceId = $row["alliance_id"];
		
		return $player;	
	}
	
	public static function CountAll()
	{
		$dbManager = DBManager::GetInstance();

		$query = sprintf("SELECT count(*) as playerCount FROM `%s`", DBConstants::PLAYER_TABLE_NAME);
		$rows = $dbManager->PerformQuery($query);
		
		if (!$rows)
		{
			return NULL;
		}
		
		$players = array();		
		$row = mysql_fetch_assoc($rows);		
		return $row["playerCount"];
	}
	
	public static function CreateNewPlayer($login, $password, $email, $nick, $address, $age, $homePlanetId)
	{
		$dbManager = DBManager::GetInstance();
		
		if ($nick == NULL)
		{
			$nick = "";
		}

		$query = sprintf("INSERT INTO `%s` (login, heslo, email, nick, address, age, home_planet) VALUES ('%s', '%s', '%s', '%s', '%s', %d, %d)", 
			DBConstants::PLAYER_TABLE_NAME, $login, $password, $email, $nick, $address, $age, $homePlanetId);
		$data = $dbManager->PerformQuery($query);
		
		return Player::LoadFromDB($dbManager->GetLastId());
	}
	
	public function RemoveFromDB()
	{
		$dbManager = DBManager::GetInstance();

		$query = sprintf("DELETE FROM `%s` WHERE ID=%d", DBConstants::PLAYER_TABLE_NAME, $this->id);
		$data = $dbManager->PerformQuery($query);
		
		//echo "mazu ". $this->GetId() ."<br/>";
		
		return 1;
	}
	
	/**
	 * Loads ships for this player from DB.
	 * Does not return anything, use GetShips() to access result.
	 */
	public function LoadShipsFromDB()
	{
		$dbManager = DBManager::GetInstance();

		$query = sprintf("SELECT ID FROM `%s` WHERE majitel=%d", DBConstants::SHIP_TABLE_NAME, $this->id);
		$rows = $dbManager->PerformQuery($query);

		if (!$rows)
		{
			return NULL;
		}

		$this->ships = array();

		while ($row = mysql_fetch_assoc($rows))
		{
			$ship = Ship::LoadFromDB($row["ID"]);
			$this->ships[$ship->GetId()] = $ship;
		}
	}
	
	public function LoadBasesFromDB()
	{
		$dbManager = DBManager::GetInstance();

		$query = sprintf("SELECT id FROM `%s` WHERE player_id=%d", DBConstants::BASE_TABLE_NAME, $this->id);
		$rows = $dbManager->PerformQuery($query);

		if (!$rows)
		{
			return NULL;
		}

		$this->bases = array();

		while ($row = mysql_fetch_assoc($rows))
		{
			$base = Base::LoadFromDB($row["id"]);
			$this->bases[$base->GetId()] = $base;
		}
	}
	
	public function LoadMessagesFromDB()
	{
		$dbManager = DBManager::GetInstance();

		$query = sprintf("SELECT id FROM `%s` WHERE reciever_id=%d", DBConstants::MESSAGE_TABLE_NAME, $this->id);
		$rows = $dbManager->PerformQuery($query);

		if (!$rows)
		{
			return NULL;
		}

		$this->messages = array();

		while ($row = mysql_fetch_assoc($rows))
		{
			$message = Message::LoadFromDB($row["id"]);
			$this->messages[$message->GetId()] = $message;
		}
	}
	
	public function LoadAllianceInvitationsFromDB()
	{
		$dbManager = DBManager::GetInstance();

		$query = sprintf("SELECT id FROM `%s` WHERE invited_id=%d", DBConstants::ALLIANCE_INVITATION_TABLE_NAME, $this->id);
		$rows = $dbManager->PerformQuery($query);

		if (!$rows)
		{
			return NULL;
		}

		$this->allianceInvitations = array();

		while ($row = mysql_fetch_assoc($rows))
		{
			$invitation = AllianceInvitation::LoadFromDB($row["id"]);
			$this->allianceInvitations[$invitation->GetId()] = $invitation;
		}
	}
	
	public function LoadLatestLogRecordsFromDB($topCount = 50)
	{
		$dbManager = DBManager::GetInstance();

		$query = sprintf("SELECT id FROM `%s` WHERE player_id=%d AND date <= %d ORDER BY date DESC LIMIT %d", 
			DBConstants::ACTION_LOG_TABLE_NAME, $this->id, time(), $topCount);
		$rows = $dbManager->PerformQuery($query);

		if (!$rows)
		{
			return NULL;
		}

		$records = array();

		while ($row = mysql_fetch_assoc($rows))
		{
			$record = ActionLogRecord::LoadFromDB($row["id"]);
			$records[$record->GetId()] = $record;
		}
		
		return $records;
	}
}

?>