<?php

require_once("Control/DBManager.inc");
require_once("Control/DBConstants.inc");
require_once("Model/GoodClass.inc");
require_once("Model/ShipType.inc");

/**
 * Class represents ship model.
 * Image of database entity "lode".
 */
class ShipModel
{
/**
	 * ID of ship model as in DB.
	 */
	private $id;
	 
	/**
	 * Gets ID ship model as in DB.
	 */
	public function GetId()
	{
		return $this->id;		
	}
	
	private $name;
	
	public function GetName()
	{
		return $this->name;	
	}
	
	private $speed;
	
	public function GetSpeed()
	{
		return $this->speed;
	}
	
	private $capacity;
	
	public function GetCapacity()
	{
		return $this->capacity;
	}
	
	private $price;
	
	public function GetPrice()
	{
		return $this->price;
	}
	
	private $image;
	
	public function GetImage()
	{
		return $this->image;
	}
	
	private $aspectRatio;
	
	public function GetAspectRatio()
	{
		return $this->aspectRatio;
	}
	
	private $shipType;
	
	public function GetShipType()
	{
		return $this->shipType;
	}
	
	protected function __construct($id) 
	{ 
		$this->id = $id;
		$this->ships = array();	
	}
	
	public static function LoadAllFromDB()
	{
		$dbManager = DBManager::GetInstance();

		$query = sprintf("SELECT ID FROM `%s`", DBConstants::SHIP_MODEL_TABLE_NAME);
		$rows = $dbManager->PerformQuery($query);
		
		if (!$rows)
		{
			return NULL;
		}
		
		$models = array();
		
		while ($row = mysql_fetch_assoc($rows))
		{
			$model = self::LoadFromDB($row["ID"]);	
			$models[$model->GetId()] = $model;
		}
		
		return $models;
	}
	
	/**
	 * Loads ship model from DB.
	 * @param $id id of player in DB
	 * @return void
	 */
	public static function LoadFromDB($id)
	{
		if ($id <= 0)
		{
			throw new Exception("Id must be positive integer.");
		}
		
		$dbManager = DBManager::GetInstance();

		$query = sprintf("SELECT * FROM `%s` WHERE ID=%d", DBConstants::SHIP_MODEL_TABLE_NAME, $id);
		$data = $dbManager->PerformQueryAssoc($query);
		
		if (!$data)
		{
			return NULL;
		}	

		$shipModel = new ShipModel($data["ID"]);
		$shipModel->name = $data["nazev"];
		$shipModel->speed = $data["rychlost"];
		$shipModel->capacity = $data["nosnost"];
		$shipModel->price = $data["cena"];
		$shipModel->image = $data["obrazek"];
		$shipModel->aspectRatio = $data["pomer_stran"];
		$shipModel->shipType = ShipType::LoadFromDB($data["ship_type"]);
		
		return $shipModel;
	}
}

?>