function GameInit()
{
	if (planetIds == null)
	{
		return;
	}
	
	GetScreenSize();
	GamePlan_UpdateGamePlan();
	LogViewPanel_StartAutoUpdate();
	
	//SwitchTraj('even');
}

function UpdateComponents()
{
	GamePlan_UpdateBtnGalaxyAction();
}

function SwitchTraj(mode)
{
	var elements = document.getElementsByName("GamePlan_Planet_Trajectory_" + mode);
		
	for (var key in elements) 
	{   
		if (elements[key] == null || elements[key].style == null)
		{
			continue;
		}
   		elements[key].style.display = "block";
	}  
	
	if (mode == "odd")
	{
		mode = "even";
	}
	else
	{
		mode = "odd";
	}
	
	elements = document.getElementsByName("GamePlan_Planet_Trajectory_" + mode);
	
	for (var key in elements) 
	{   
		if (elements[key] == null || elements[key].style == null)
		{
			continue;
		}
   		elements[key].style.display = "none";
	}
	
	setTimeout("SwitchTraj('"+mode+"')", 250);
}

//////////////////////////////////////////////////////////////////////////////////////////
/// GamePlan.inc
//////////////////////////////////////////////////////////////////////////////////////////

var REFRESH_TIME = 100;
var DAY_LENGTH_MS = 0;
var planetIds;
var shipIds;

function GamePlan_OnClick(gamePlan, event)
{
	event.cancelBubble = true;
	
	ShipGraphic_SelectShip(null);
	PlanetInfoPanel_HideOpenedPanel();
	MenuPanel_SelectPlanet(null);
	UpdateComponents();
}

function GamePlan_OnMouseOut(gamePlan, event)
{
	var gamePlan = document.getElementById("GamePlan");
		
	if (!IsChildParent(event.relatedTarget, gamePlan))
	{
		PlanetInfoPanel_HideOpenedPanel();
	}	
}

function GamePlan_SunClick(event)
{
	event.cancelBubble = true;
	ShipGraphic_SelectShip(null);
	MenuPanel_SelectSun();
	PlanetInfoPanel_HideOpenedPanel();
	UpdateComponents();
}

function GamePlan_StartAnimation(planets, ships, dayLengthMs)
{
	planetIds = planets;
	shipIds = ships;
	DAY_LENGTH_MS = dayLengthMs;
	//GameInit();
}

function GamePlan_UpdateGamePlan()
{
	GamePlan_SyncPositions("planet");
	GamePlan_SyncPositions("ship");
}

function MotionRecord(id) 
{ 
	this.id = id;
	this.element = null;
	this.oldX = 0.0;
	this.oldY = 0.0;
	this.nextX = 0.0;
	this.nextY = 0.0;	
	this.visible = true;
}

function GamePlan_SyncPositions(mode)
{
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{
			GamePlan_ParsePositionFromServer(xmlhttp.responseText, mode);
		}
	}

	var action = "";
	
	if (mode == "planet")
	{
		action = "GetPlanetPositions";
	}
	else if (mode == "ship")
	{
		action = "GetShipPositions";
	}
	
	var url = "responder.php?action=" + action + 
		"&screenWidth=" + screenWidth +
		"&screenHeight=" + screenHeight +
		"&rand=" + Math.random();
		
	xmlhttp.open("GET", url, true);
	xmlhttp.send(null);
}

function GamePlan_ParsePositionFromServer(newPositions, type)
{
	//if (type == "ship") alert(newPositions);
	//alert(newPositions);
	var motionRecords = new Array();
	var shipUpdateIds = new Array();
	var ratio = 0.0;
	
	var lines = newPositions.split("$");
	
	var i;
 	for (i = 0; i < lines.length; i++)
 	{
 		// object_id;oldX;oldY;newX;newY;ratio within day;visible;stateCode
 		var tokens = lines[i].split(";");

		if (tokens.length < 6)
		{
			continue;
		}
 		
 		var motionRecord = new MotionRecord(parseInt(tokens[0]));
		motionRecord.oldX = parseFloat(tokens[1]);
 		motionRecord.oldY = parseFloat(tokens[2]);
 		motionRecord.nextX = parseFloat(tokens[3]);
 		motionRecord.nextY = parseFloat(tokens[4]);
		motionRecord.visible = true;
		if (tokens.length >= 7)
		{
			motionRecord.visible = (tokens[6] != "false");
		}
		
 		if (type == "planet")
 		{
 			motionRecord.element = document.getElementById(planetIds[tokens[0]]);
			
			if (motionRecord.element == null)
			{
				continue;
			}
						
			var infoPanel = document.getElementById(motionRecord.element.id + "_PlanetInfoPanel");
			if (infoPanel.style.display != 'none')
			{
				PlanetInfoPanel_FitToGamePlan(infoPanel);
			}
			
			if (tokens.length >= 8)
			{
				PlanetGraphic_CheckStateCode(motionRecord.element, tokens[7]);
			}
 		}
 		else if (type == "ship")
 		{
 			motionRecord.element = document.getElementById(shipIds[tokens[0]]);
			shipUpdateIds.push(tokens[0]);
			if (motionRecord.element == null)
			{
				continue;
			}
 		}
		
 		motionRecords.push(motionRecord);
		
 		ratio = parseFloat(tokens[5]); 		
 	}

	if (type == "ship") 
	{
		GamePlan_CheckShipList(shipUpdateIds);
	}
	
 	GamePlan_UpdatePositions(motionRecords, ratio, type);	
}

function GamePlan_UpdatePositions(motionRecords, ratio, mode)
{
	var i;
	for (i = 0; i < motionRecords.length; i++)
	{
		var record = motionRecords[i];
		var finalX = record.oldX + (record.nextX - record.oldX) * ratio;
		var finalY = record.oldY + (record.nextY - record.oldY) * ratio;
		
		record.element.style.left = (finalX - parseFloat(record.element.style.width) / 2) + "px";
		record.element.style.top = (finalY - parseFloat(record.element.style.height) / 2) + "px";
		
		if (record.visible) 
		{
			record.element.style.display = "block";
		}
		else
		{
			record.element.style.display = "none";
		}
	}
	
	ratio += REFRESH_TIME / DAY_LENGTH_MS;

	if (ratio < 1)
	{
		setTimeout(
				function()
				{
					GamePlan_UpdatePositions(motionRecords, ratio, mode);
				}, 
				REFRESH_TIME
				);
	}
	else 
	{
		GamePlan_SyncPositions(mode);
	}
}

function GamePlan_CheckShipList(shipUpdateIds)
{
	//alert("UPDATE: " + shipUpdateIds.join());
	
	shipIdsClone = new Array();
	
	for (var key in shipIds)
	{
		shipIdsClone[key] = shipIds[key];
	}
	
	var shipChecked = new Array();
	
	for (var key in shipUpdateIds)
	{
		if (shipIdsClone[shipUpdateIds[key]] == null)
		{
			ShipGraphic_AddNewToPlan(shipUpdateIds[key]);
		}
		else
		{
			shipChecked[shipUpdateIds[key]] = true;
		}		
	}
	
	for (var key in shipIdsClone)
	{
		if (!shipChecked[key])
		{
			var shipElem = document.getElementById(shipIdsClone[key]);
			if (shipElem != null) 
			{
				ShipGraphic_RemoveFromPlan(shipElem);
			}
		}
	}
}

function GamePlan_SetTrajectoriesEnabled(enabled)
{
	var display = 'none';
	
	if (enabled)
	{
		display = 'block';
	}
	
	var elements = document.getElementsByName("GamePlan_Planet_Trajectory_odd");
		
	for (var key in elements) 
	{   
		if (elements[key] == null || elements[key].style == null)
		{
			continue;
		}
		
   		elements[key].style.display = display;
	}
	
	elements = document.getElementsByName("GamePlan_Planet_Trajectory_even");
	
	for (var key in elements) 
	{   
		if (elements[key] == null || elements[key].style == null)
		{
			continue;
		}
		
   		elements[key].style.display = display;
	}
}

function GamePlan_UpdateBtnGalaxyAction()
{
	var btnElem = document.getElementById("GamePlan_btnGalaxyAction");
	
	if (ShipGraphic_selectedShip == null)
	{
		var lblElem = document.getElementById("GamePlan_btnGalaxyActionLblBrowse");
		btnElem.innerHTML = lblElem.value;
		btnElem.style.display = "none";
	}
	else
	{
		var lblElem = document.getElementById("GamePlan_btnGalaxyActionLblFreeNav");
		var shipName = document.getElementById(ShipGraphic_selectedShip.id + "_shipName").value;
		btnElem.innerHTML = sprintf(lblElem.value, shipName);
		btnElem.style.display = "block";
	}
}

function GamePlan_BtnGalaxyActionOnClick(btnElem, event)
{
	event.cancelBubble = true;
	
	if (ShipGraphic_selectedShip == null) 
	{
		GalaxyMap_Show();
	}
	else
	{
		var shipId = document.getElementById(ShipGraphic_selectedShip.id + "_shipId").value;
		GalaxyMap_Show(shipId);
	}
}

//////////////////////////////////////////////////////////////////////////////////////////
/// PlanetGraphic.inc
//////////////////////////////////////////////////////////////////////////////////////////

var PlanetGraphic_shipFirstUsed;

function PlanetGraphic_OnClick(planet, event)
{
	event.cancelBubble = true;
		
	if (ShipGraphic_selectedShip == null)
	{
		//PlanetInfoPanel_ShowForPlanet(planet);
		MenuPanel_SelectPlanet(planet);
		PlanetGraphic_shipFirstUsed = null;
		PlanetInfoPanel_ShowForPlanet(planet);
	}
	else
	{
		//ShipGraphic_SelectShip(null);
		if (PlanetGraphic_shipFirstUsed == ShipGraphic_selectedShip) 
		{
			PlanetGraphic_shipFirstUsed = null;
			ShipGraphic_FlyShipToTarget(ShipGraphic_selectedShip, planet, "planet");
		}
		else
		{
			MenuPanel_SelectPlanet(planet);
			PlanetGraphic_shipFirstUsed = ShipGraphic_selectedShip;
			setTimeout('PlanetGraphic_shipFirstUsed = null', 1000);
		}		
	}
	
	UpdateComponents();
}

function PlanetGraphic_OnMouseOver(planet, event)
{
	event.cancelBubble = true;
			
	if (ShipGraphic_selectedShip != null) 
	{
		planet.title = document.getElementById(planet.id + "_lblFlyHere").value;
		planet.style.cursor = "crosshair";
	}
	else
	{
		planet.title = document.getElementById(planet.id + "_lblSelect").value;
		planet.style.cursor = "pointer";
	}
}

function PlanetGraphic_CheckStateCode(planet, stateCode)
{		
	if (planet == null)
	{
		return false;
	}
	
	var stateCodeLocal = document.getElementById(planet.id + "_stateCode").value;
	
	if (stateCode == stateCodeLocal)
	{
		return;
	}
		
	var planetId = document.getElementById(planet.id + "_planetId").value;
	
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{
			var response = xmlhttp.responseText;
			//alert(response);
			planet.innerHTML = response;
			planet.style.display = 'block';
		}
	}

	var url = "responder.php?action=GetPlanetGraphic" + 
		"&planetId=" + planetId +
		"&planetGraphicId=" + planet.id +
		"&rand=" + Math.random();
	
	xmlhttp.open("POST", url, true);
	xmlhttp.send(null);
}

//////////////////////////////////////////////////////////////////////////////////////////
/// PlanetInfoPanel.inc
//////////////////////////////////////////////////////////////////////////////////////////

var PlanetInfoPanel_openedPanel = null;

function PlanetInfoPanel_OnClick(panel, event)
{
	event.cancelBubble = true;
	PlanetInfoPanel_Hide(panel);
}

function PlanetInfoPanel_ShowForPlanet(planet)
{	
	PlanetInfoPanel_HideOpenedPanel();
	
	var planetId = document.getElementById(planet.id + "_planetId").value;
	
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{
			var response = xmlhttp.responseText;
			
			var element = document.getElementById(planet.id + "_PlanetInfoPanel");
			PlanetInfoPanel_openedPanel = element;
			
			element.innerHTML = response;
			PlanetInfoPanel_FitToGamePlan(element);
						
			element.style.zIndex = 100;
			element.style.display = 'block';
		}
	}

	var url = "responder.php?action=GetPlanetInfoPanel" + 
		"&planetId=" + planetId +
		"&rand=" + Math.random();
	
	xmlhttp.open("POST", url, true);
	xmlhttp.send(null);
}

function PlanetInfoPanel_FitToGamePlan(infoPanel)
{
	var infoX = parseFloat(infoPanel.style.left);
	var infoY = parseFloat(infoPanel.style.top);
	var infoWidth = parseFloat(infoPanel.style.width);
	var infoHeight = parseFloat(infoPanel.style.height);
	
	var planet = infoPanel.parentNode;
	var planetX = parseFloat(planet.style.left);
	var planetY = parseFloat(planet.style.top);
	
	var gamePlan = document.getElementById("GamePlan");
	var planWidth = parseFloat(gamePlan.style.width);
	var planHeight = parseFloat(gamePlan.style.height);
	
	//alert(planetX + "+" + infoX + " + " + infoWidth + " ? " + planWidth)
		
	if (planetX + infoX + infoWidth > planWidth)
	{
		infoX = planWidth - infoWidth - planetX;
	}
	
	if (planetY + infoY + infoHeight > planHeight)
	{
		infoY = planHeight - infoHeight - planetY;
	}
	
	if (planetX + infoX < 0)
	{
		infoX = 0 - planetX;
	}
	
	if (planetY + infoY < 0)
	{
		infoY = 0 - planetY;
	}
	
	infoPanel.style.left = infoX + "px";
	infoPanel.style.top = infoY + "px";
}

function PlanetInfoPanel_HideOpenedPanel()
{
	if (PlanetInfoPanel_openedPanel != null)
	{
		PlanetInfoPanel_Hide(PlanetInfoPanel_openedPanel);
	}
}

function PlanetInfoPanel_Hide(panelElement)
{
	panelElement.style.display = 'none';
}

//////////////////////////////////////////////////////////////////////////////////////////
/// ShipGraphic.inc
//////////////////////////////////////////////////////////////////////////////////////////

var ShipGraphic_selectedShip = null;
var ShipGraphic_BORDER_WIDTH = 4;

function ShipGraphic_OnClick(ship, event)
{
	event.cancelBubble = true;
	PlanetInfoPanel_HideOpenedPanel();
	
	MenuPanel_SelectShip(ship);
	if (ship != ShipGraphic_selectedShip)
	{
		ShipGraphic_SelectShip(ship);		
	}
	
	UpdateComponents();
}

function ShipGraphic_SetHighlight(ship, highlight)
{
	var image = ship.childNodes[1];
	
	if (highlight)
	{
		SetOpacity(image, 0.5);
	}
	else 
	{
		if (ship != ShipGraphic_selectedShip)
		{
			SetOpacity(image, 1.0);
		}
		else 
		{
			SetOpacity(image, 0.7);
		}
	}
}

function ShipGraphic_SelectShip(ship)
{
	if (ship == ShipGraphic_selectedShip)
	{
		return;
	}
	
	var oldShip = ShipGraphic_selectedShip;
	ShipGraphic_selectedShip = ship;
	
	if (oldShip != null)
	{
		ShipGraphic_SetHighlight(oldShip, false);
		SetElementBorderWidth(oldShip, 0);
	}
	
	if (ShipGraphic_selectedShip != null)
	{
		SetElementBorderWidth(ShipGraphic_selectedShip, ShipGraphic_BORDER_WIDTH);
	}	
}

function ShipGraphic_GetShipCenterXY(ship)
{
	var shipX = parseFloat(ship.style.left) + parseFloat(ship.style.width) / 2 + parseFloat(ship.style.borderWidth);
	var shipY = parseFloat(ship.style.top) + parseFloat(ship.style.height) / 2 + parseFloat(ship.style.borderWidth);
	
	return new Array(shipX, shipY);
}

function ShipGraphic_SetShipCenterXY(ship, x, y)
{
	ship.style.left = (x - parseFloat(ship.style.width) / 2 - parseFloat(ship.style.borderWidth)) + "px";
	ship.style.top = (y - parseFloat(ship.style.height) / 2 - parseFloat(ship.style.borderWidth)) + "px";
}

var STEP_LENGTH = 2.0;
var shipTargets = null;

function ShipGraphic_AnimateShipToPlanet(ship, planet)
{
	if (shipTargets == null)
	{
		ShipGraphic_StartShipAnimations();
	}
	
	shipTargets[ship.id] = planet; 
}

function ShipGraphic_StartShipAnimations()
{
	shipTargets = new Array();
	ShipGraphic_AnimateShips();
}

function ShipGraphic_AnimateShips()
{
	for (var shipId in shipTargets)
	{
		ShipGraphic_MakeStep(document.getElementById(shipId), shipTargets[shipId]);
	}
	
	setTimeout('ShipGraphic_AnimateShips()', 50);
}

function ShipGraphic_MakeStep(ship, planet)
{
	var shipCoords = ShipGraphic_GetShipCenterXY(ship);
	var shipX = shipCoords[0];
	var shipY = shipCoords[1];
	
	var planetX = parseFloat(planet.style.left) + parseFloat(planet.style.width) / 2;
	var planetY = parseFloat(planet.style.top) + parseFloat(planet.style.height) / 2;
	
	var dx = planetX - shipX;
	var dy = planetY - shipY;
	
	var distance = Math.sqrt(dx * dx + dy * dy);
	
	if (distance > 4)
	{
		dx = dx * STEP_LENGTH / distance;
		dy = dy * STEP_LENGTH / distance;
	}
		
	ShipGraphic_SetShipCenterXY(ship, shipX + dx, shipY + dy);
}

function ShipGraphic_FlyShipToTarget(ship, target, targetType)
{
	if (ship == null || target == null)
	{
		return false;
	}
	
	var shipId = document.getElementById(ship.id + "_shipId").value;
	
	if (targetType == "planet")
	{		
		var targetId =  document.getElementById(target.id + "_planetId").value;
	}
	else if (targetType == "wormhole")
	{		
		var targetId =  document.getElementById(target.id + "_wormHoleId").value;
	}
	else
	{
		return false;
	}	
	
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{
			var response = xmlhttp.responseText;
			//alert(response);
			
			if (response == "1") 
			{
				MenuPanel_SelectShip(ship);
            }
            else 
			{
				alert(response);
				MenuPanel_SelectShip(ship);
            }
		}
	}

	var url = "responder.php?action=FlyShipToTarget" + 
		"&targetType=" + targetType +
		"&shipId=" + shipId +
		"&targetId=" + targetId +
		"&rand=" + Math.random();
	
	xmlhttp.open("POST", url, true);
	xmlhttp.send(null);
}

function ShipGraphic_AddNewToPlan(shipId)
{
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{
			var response = xmlhttp.responseText;
			
			if (shipIds[shipId] != null)
			{
				return;
			}
			
			var tempDiv = document.createElement("div");
			tempDiv.innerHTML = response;
			
			for (var key in tempDiv.childNodes)
			{
				var node = tempDiv.childNodes[key];
				if (node.className == "ShipGraphic")
				{
					break;
				}
			}
			
			var shipDiv = node;
			shipDiv.style.display = "none";
			shipIds[shipId] = shipDiv.id;
			
			var shipContainer = document.getElementById("GamePlan_shipContainer");
			shipContainer.appendChild(shipDiv);
		}
	}

	var url = "responder.php?action=GetShipGraphic" + 
		"&shipId=" + shipId +
		"&rand=" + Math.random();
	
	xmlhttp.open("POST", url, true);
	xmlhttp.send(null);
}

function ShipGraphic_RemoveFromPlan(shipElem)
{
	if (shipElem == ShipGraphic_selectedShip)
	{
		ShipGraphic_selectedShip = null;
	}
	
	var shipId = document.getElementById(shipElem.id + "_shipId").value;
	shipIds[shipId] = null;
	
	var shipContainer = document.getElementById("GamePlan_shipContainer");
	shipContainer.removeChild(shipElem);
}

//////////////////////////////////////////////////////////////////////////////////////////
/// MenuPanel.inc
//////////////////////////////////////////////////////////////////////////////////////////

var MenuPanel_onLoadOnce = null;

function MenuPanel_SelectPlanet(planet)
{
	var selectionType = "none";
	var planetId = 0;
	
	if (planet != null)
	{
		var planetIdFieldId = planet.id + "_planetId";
		var planetIdField = document.getElementById(planetIdFieldId);
		var planetId = planetIdField.value;
		selectionType = "planet";
	}
	
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{
			var menuPanel = document.getElementById("MenuPanel");
			var response = xmlhttp.responseText;
			menuPanel.innerHTML = response;
			if (MenuPanel_onLoadOnce != null)
			{
				MenuPanel_onLoadOnce();
				MenuPanel_onLoadOnce = null;
			}
		}
	}

	var url = "responder.php?action=GetMenu" + 
		"&itemId=" + planetId +
		"&selectionType=" + selectionType +
		"&rand=" + Math.random();
	
	xmlhttp.open("POST", url, true);
	xmlhttp.send(null);
}

function MenuPanel_SelectShip(ship)
{
	var selectionType = "none";
	var shipId = 0;
	
	if (ship != null)
	{
		var shipIdFieldId = ship.id + "_shipId";
		var shipIdField = document.getElementById(shipIdFieldId);
		var shipId = shipIdField.value;
		selectionType = "ship";
	}
	
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{
			var menuPanel = document.getElementById("MenuPanel");
			var response = xmlhttp.responseText;
			menuPanel.innerHTML = response;
			if (MenuPanel_onLoadOnce != null)
			{
				MenuPanel_onLoadOnce();
				MenuPanel_onLoadOnce = null;
			}
		}
	}

	var url = "responder.php?action=GetMenu" + 
		"&itemId=" + shipId +
		"&selectionType=" + selectionType +
		"&rand=" + Math.random();
	
	xmlhttp.open("POST", url, true);
	xmlhttp.send(null);
}

function MenuPanel_SelectHome()
{
	ShipGraphic_SelectShip(null);
	MenuPanel_SelectShip(null);
}

function MenuPanel_SelectSun()
{
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{
			var menuPanel = document.getElementById("MenuPanel");
			var response = xmlhttp.responseText;
			menuPanel.innerHTML = response;
			if (MenuPanel_onLoadOnce != null)
			{
				MenuPanel_onLoadOnce();
				MenuPanel_onLoadOnce = null;
			}
		}
	}

	var url = "responder.php?action=GetMenu" + 
		"&itemId=" + 0 +
		"&selectionType=" + "sun" +
		"&rand=" + Math.random();
	
	xmlhttp.open("POST", url, true);
	xmlhttp.send(null);
}

function MenuPanel_BuildBase(planetId)
{
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{
			// assume success
			var response = xmlhttp.responseText;
			//alert(response);
			
			if (response == "1") 
			{
                var planetBaseStateElem = document.getElementById(planetIds[planetId]+ "_baseState");
				planetBaseStateElem.value = "progress";
				
            }
            else 
			{
                alert("ERROR: Couldn't build new base!");
            }
		}
	}

	var url = "responder.php?action=BuildBase" + 
		"&planetId=" + planetId +
		"&rand=" + Math.random();
	
	xmlhttp.open("POST", url, true);
	xmlhttp.send(null);
}

function MenuPanel_BuyLicence(isRecursion)
{
	var hasMoney = document.getElementById("MenuPanel_hasMoney").value;
	var question = document.getElementById("MenuPanel_question").value;
	
	if (hasMoney == "false")
	{
		if (!isRecursion) 
		{
			alert(question);
			MenuPanel_onLoadOnce = function()
			{
				MenuPanel_BuyLicence(true);
			}
			MenuPanel_SelectHome();
		}
		return;
	}
	
	if (!confirm(question))
	{
		return;
	}
	
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{
			// assume success
			var response = xmlhttp.responseText;
			//alert(response);
			
			if (response == "1") 
			{
                document.location.reload();
            }
            else 
			{
				alert(response);
            }
		}
	}

	var url = "responder.php?action=BuyLicence" + 
		"&rand=" + Math.random();
	
	xmlhttp.open("POST", url, true);
	xmlhttp.send(null);
}


function MenuPanel_BuyEmbassyLevel(menuPanelId, isRecursion)
{
	var hasMoney = document.getElementById(menuPanelId + "_embassyLevelEnabled").value;
	var question = document.getElementById(menuPanelId + "_emabssyQuestion").value;
	
	if (hasMoney == "false")
	{
		if (!isRecursion) 
		{
			alert(question);
			MenuPanel_onLoadOnce = function()
			{
				MenuPanel_BuyEmbassyLevel(menuPanelId, true);
			}
			MenuPanel_SelectHome();
		}
		return;
	}
	
	if (!confirm(question))
	{
		return;
	}
	
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{
			// assume success
			var response = xmlhttp.responseText;
			//alert(response);
			
			if (response == "1") 
			{
                document.location.reload();
            }
            else 
			{
				alert(response);
            }
		}
	}

	var url = "responder.php?action=BuyEmbassyLevel" + 
		"&rand=" + Math.random();
	
	xmlhttp.open("POST", url, true);
	xmlhttp.send(null);
}

function MenuPanel_BuyShipLevel(menuPanelId, shipId, isRecursion)
{
	var hasMoney = document.getElementById(menuPanelId + "_canLevel").value;
	var question = document.getElementById(menuPanelId + "_question").value;
	
	if (hasMoney == "false")
	{
		if (!isRecursion) 
		{
			alert(question);
			MenuPanel_onLoadOnce = function()
			{
				MenuPanel_BuyLevel(menuPanelId, shipId, true);
			}
			MenuPanel_SelectShip(document.getElementById(shipIds[shipId]));
		}
		return;
	}
	
	if (!confirm(question))
	{
		return;
	}
	
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{
			// assume success
			var response = xmlhttp.responseText;
			//alert(response);
			
			if (response == "1") 
			{
                document.location.reload();
				MenuPanel_SelectShip(document.getElementById(shipIds[shipId]));
            }
            else 
			{
				alert(response);
            }
		}
	}

	var url = "responder.php?action=BuyShipLevel" + 
		"&shipId=" + shipId + 
		"&rand=" + Math.random();
	
	xmlhttp.open("POST", url, true);
	xmlhttp.send(null);
}

function MenuPanel_FinishDeliveries(shipId, isLocalDelivery, targetSystemId)
{
	if (isLocalDelivery)
	{
		MenuPanel_FinishDeliveriesLocal(shipId);
	}
	else
	{
		GalaxyMap_Show(shipId, null, targetSystemId);
	}
}

function MenuPanel_FinishDeliveriesLocal(shipId)
{
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{
			var response = xmlhttp.responseText;
			//alert(response);
			
			if (response == "1") 
			{
				MenuPanel_SelectShip(document.getElementById(shipIds[shipId]));
            }
            else 
			{
				alert(response);
				document.location.reload();
            }
		}
	}

	var url = "responder.php?action=FinishDeliveries" + 
		"&shipId=" + shipId + 
		"&rand=" + Math.random();
	
	xmlhttp.open("POST", url, true);
	xmlhttp.send(null);
}

//////////////////////////////////////////////////////////////////////////////////////////
/// DeliveryPanel.inc
//////////////////////////////////////////////////////////////////////////////////////////

function DeliveryPanel_OnClick(event)
{
	event.cancelBubble = true;
}

function DeliveryPanel_Show(planetId, sortKey, sortOrder)
{	
	if (sortKey == null)
	{
		sortKey = "reward";
	}
	
	if (sortOrder == null)
	{
		sortOrder = "desc";
	}
	
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{
			var panel = document.getElementById("DeliveryPanel");		
			var response = xmlhttp.responseText;
			panel.innerHTML = response;
			panel.style.display = 'block';
		}
	}

	var url = "responder.php?action=GetDeliveryPanel" + 
		"&planetId=" + planetId +
		"&sortKey=" + sortKey +
		"&sortOrder=" + sortOrder +
		"&rand=" + Math.random();
	
	xmlhttp.open("POST", url, true);
	xmlhttp.send(null);
}

function DeliveryPanel_Hide()
{
	var panel = document.getElementById("DeliveryPanel");			
	panel.style.display = 'none';
}

//////////////////////////////////////////////////////////////////////////////////////////
/// ShipSelectionPanel.inc
//////////////////////////////////////////////////////////////////////////////////////////

function ShipSelectionPanel_OnClick(event)
{
	event.cancelBubble = true;
}

function ShipSelectionPanel_Show(deliveryId)
{
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{
			var panel = document.getElementById("ShipSelectionPanel");		
			var response = xmlhttp.responseText;
			panel.innerHTML = response;
			panel.style.display = 'block';
			panel.style.zIndex = 400;
		}
	}

	var url = "responder.php?action=GetShipSelectionPanel" + 
		"&deliveryId=" + deliveryId +
		"&rand=" + Math.random();
	
	xmlhttp.open("POST", url, true);
	xmlhttp.send(null);
}

function ShipSelectionPanel_Hide()
{
	var panel = document.getElementById("ShipSelectionPanel");			
	panel.style.display = 'none';
}

function ShipSelectionPanel_Deliver(shipId, deliveryId, isShipInSystem)
{
	ShipSelectionPanel_Hide();
	DeliveryPanel_Hide();
	
	//var isLocalDelivery = document.getElementById("ShipSelectionPanel_isLocalDelivery").value;
	
	if (isShipInSystem)
	{
		ShipSelectionPanel_DeliverLocal(shipId, deliveryId, false);
	}
	else
	{
		GalaxyMap_Show(shipId, deliveryId);
	}
}

function ShipSelectionPanel_DeliverLocal(shipId, deliveryId, ignoreShipBusy)
{	
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{
			// assume success
			var response = xmlhttp.responseText;
			//alert(response);
			
			if (response == "1") 
			{
                //document.location.reload();
            }
            else 
			{
                alert(response);
            }
		}
	}

	var url = "responder.php?action=DeliverDelivery" + 
		"&shipId=" + shipId +
		"&deliveryId=" + deliveryId +
		"&ignoreShipBusy=" + (ignoreShipBusy ? "true" : "false") +
		"&rand=" + Math.random();
	
	xmlhttp.open("POST", url, true);
	xmlhttp.send(null);
}

//////////////////////////////////////////////////////////////////////////////////////////
/// DeliveryPanel.inc
//////////////////////////////////////////////////////////////////////////////////////////

function PlanetHomePlayersPanel_OnClick(event)
{
	event.cancelBubble = true;
}

function PlanetHomePlayersPanel_Show(planetId)
{	
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{
			var panel = document.getElementById("PlanetHomePlayersPanel");		
			var response = xmlhttp.responseText;
			panel.innerHTML = response;
			panel.style.display = 'block';
		}
	}

	var url = "responder.php?action=GetPlanetHomePlayersPanel" + 
		"&planetId=" + planetId +
		"&rand=" + Math.random();
	
	xmlhttp.open("POST", url, true);
	xmlhttp.send(null);
}

function PlanetHomePlayersPanel_Hide()
{
	var panel = document.getElementById("PlanetHomePlayersPanel");			
	panel.style.display = 'none';
}

//////////////////////////////////////////////////////////////////////////////////////////
/// ShipShopPanel.inc
//////////////////////////////////////////////////////////////////////////////////////////

function ShipShopPanel_OnClick(event)
{
	event.cancelBubble = true;
}

function ShipShopPanel_Show()
{	
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{
			var panel = document.getElementById("ShipShopPanel");		
			var response = xmlhttp.responseText;
			panel.innerHTML = response;
			panel.style.display = 'block';
		}
	}

	var url = "responder.php?action=GetShipShopPanel" + 
		"&rand=" + Math.random();
	
	xmlhttp.open("POST", url, true);
	xmlhttp.send(null);
}

function ShipShopPanel_Hide()
{
	var panel = document.getElementById("ShipShopPanel");			
	panel.style.display = 'none';
}

function ShipShopPanel_BuyShip(modelId)
{
	var promptTextField = document.getElementById("ShipShopPanel_namePromptText");
	var promptText = promptTextField.value;
		
	var shipName = "";
	
	while (shipName.length == 0) 
	{
		shipName = window.prompt(promptText, "");
	}	
	
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{
            // assume success
            var response = xmlhttp.responseText;
            //alert("|" + response + "|");
            
            if (response == "1") 
			{
                document.location.reload();
            }
            else 
			{
                alert("ERROR: Couldn't buy ship!");
            }
		}
		
	}

	var url = "responder.php?action=BuyShip" + 
		"&modelId=" + modelId +
		"&shipName=" + shipName +
		"&rand=" + Math.random();
	
	xmlhttp.open("POST", url, true);
	xmlhttp.send(null);
}

//////////////////////////////////////////////////////////////////////////////////////////
/// HighScorePanel.inc
//////////////////////////////////////////////////////////////////////////////////////////

function HighScorePanel_OnClick(event)
{
	event.cancelBubble = true;
}

function HighScorePanel_Show(sortKey, sortOrder)
{	
	if (sortKey == null)
	{
		sortKey = "points";
	}
	
	if (sortOrder == null)
	{
		sortOrder = "desc";
	}
	
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{
			var panel = document.getElementById("HighScorePanel");		
			var response = xmlhttp.responseText;
			panel.innerHTML = response;
			panel.style.display = 'block';
		}
	}

	var url = "responder.php?action=GetHighScorePanel" + 
		"&sortKey=" + sortKey +
		"&sortOrder=" + sortOrder +
		"&rand=" + Math.random();
	
	xmlhttp.open("POST", url, true);
	xmlhttp.send(null);
}

function HighScorePanel_Hide()
{
	var panel = document.getElementById("HighScorePanel");			
	panel.style.display = 'none';
}

//////////////////////////////////////////////////////////////////////////////////////////
/// DisplayFilterPanel.inc
//////////////////////////////////////////////////////////////////////////////////////////

function DisplayFilterPanel_OnClick(event)
{
	event.cancelBubble = true;
}

function DisplayFilterPanel_Changed(item, state)
{
	var visible = state ? "block" : "none";
	
	if (item == "ships")
	{
		for (index in shipIds)
		{
			var ship = document.getElementById(shipIds[index]);
			ship.style.display = visible;
			//ship.style.zIndex = 800;//ship.parentNode.style.zIndex + 1;
		}
	}
	else if (item == "buildings")
	{
		for (index in planetIds)
		{
			var baseStar = document.getElementById(planetIds[index] + "_baseStar");
			
			if (baseStar == null)
			{
				continue;
			}
			
			baseStar.style.display = visible;
		}
	}
	else if ("trajectories")
	{
		GamePlan_SetTrajectoriesEnabled(state);
	}
}

//////////////////////////////////////////////////////////////////////////////////////////
/// LogViewPanel.inc
//////////////////////////////////////////////////////////////////////////////////////////

var LogViewPanel_shouldAutoUpdate = false;
var LogViewPanel_rowCount = 5;

function LogViewPanel_OnClick(event)
{
	event.cancelBubble = true;
	LogViewPanel_Update();
}

function LogViewPanel_StartAutoUpdate(period)
{
	if (period == null)
	{
		period = 2000;
	}
	
	LogViewPanel_shouldAutoUpdate = true;
	LogViewPanel_AutoUpdate(period);
}

function LogViewPanel_AutoUpdate(period)
{
	if (!LogViewPanel_shouldAutoUpdate)
	{
		return;
	}
	
	LogViewPanel_Update();
	setTimeout('LogViewPanel_AutoUpdate(' + period + ')', period);	
}

function LogViewPanel_StopAutoUpdate()
{
	LogViewPanel_shouldAutoUpdate = false;
}

function LogViewPanel_Update(rowCount)
{	
	if (rowCount == null)
	{
		rowCount = LogViewPanel_rowCount;
	}
	else
	{
		LogViewPanel_rowCount = rowCount; 
	}
	
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{
			var panel = document.getElementById("LogViewPanel");		
			var response = xmlhttp.responseText;
			panel.innerHTML = response;
			panel.style.display = 'block';
		}
	}

	var url = "responder.php?action=GetLogViewPanel" + 
		"&rowCount=" + rowCount +
		"&rand=" + Math.random();
	
	xmlhttp.open("POST", url, true);
	xmlhttp.send(null);
}

function LogViewPanel_Hide()
{
	var panel = document.getElementById("LogViewPanel");			
	panel.style.display = 'none';
}

//////////////////////////////////////////////////////////////////////////////////////////
/// WormHoleGraphic.inc
//////////////////////////////////////////////////////////////////////////////////////////

function WormHoleGraphic_OnClick(wormHole, event)
{
	event.cancelBubble = true;
}

function WormHoleGraphic_OnDoubleClick(wormHole, event)
{
	event.cancelBubble = true;
	
	if (ShipGraphic_selectedShip == null)
	{
		var targetSystemId = document.getElementById(wormHole.id + "_targetSystemId").value;
		WormHoleGraphic_GoToSystem(targetSystemId);
	}
	else
	{
		ShipGraphic_FlyShipToTarget(ShipGraphic_selectedShip, wormHole, "wormhole");
	}
}

function WormHoleGraphic_OnMouseOver(wormhole, event)
{
	event.cancelBubble = true;
			
	if (ShipGraphic_selectedShip != null) 
	{
		wormhole.title = document.getElementById(wormhole.id + "_lblFlyThrough").value;
		wormhole.style.cursor = "crosshair";
	}
	else
	{
		wormhole.title = document.getElementById(wormhole.id + "_lblSwitchTo").value;
		wormhole.style.cursor = "pointer";
	}
}

function WormHoleGraphic_GoToSystem(targetSystemId)
{
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{
			document.location.reload();	
		}
	}

	var url = "responder.php?action=GoToSystem" + 
		"&systemId=" + targetSystemId +
		"&rand=" + Math.random();
	
	xmlhttp.open("POST", url, true);
	xmlhttp.send(null);
}

//////////////////////////////////////////////////////////////////////////////////////////
/// GuardAssignmentPanel.inc
//////////////////////////////////////////////////////////////////////////////////////////

function GuardAssignmentPanel_OnClick(event)
{
	event.cancelBubble = true;
}

function GuardAssignmentPanel_Show()
{	
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{
			var panel = document.getElementById("GuardAssignmentPanel");		
			var response = xmlhttp.responseText;
			panel.innerHTML = response;
			panel.style.display = 'block';
		}
	}

	var url = "responder.php?action=GetGuardAssignmentPanel" + 
		"&rand=" + Math.random();
	
	xmlhttp.open("POST", url, true);
	xmlhttp.send(null);
}

function GuardAssignmentPanel_ApplyChanges(idArray)
{
	var assignmentsString = "";
	for (index in idArray)
	{
		var inputElem = document.getElementById(idArray[index]);
		var chckBoxPirates = document.getElementById(idArray[index] + '_grantPirates');
		assignmentsString += inputElem.name + ";" + inputElem.value + ";";
		assignmentsString += chckBoxPirates.checked ? "1" : "0";
		assignmentsString += "%";
	}
	
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{
			//var panel = document.getElementById("GuardAssignmentPanel");		
			var response = xmlhttp.responseText;
			if (response == "1") 
			{
				GuardAssignmentPanel_Hide();
			}
			else
			{
				document.location.reload();	
			}
		}
	}

	var url = "responder.php?action=ApplyGuardAssignments" + 
		"&assignments=" + assignmentsString +
		"&rand=" + Math.random();
	
	xmlhttp.open("POST", url, true);
	xmlhttp.send(null);
}

function GuardAssignmentPanel_GrantChanged(dropDownId)
{
	var dropDownElem = document.getElementById(dropDownId);
	var chckBoxPirates = document.getElementById(dropDownId + '_grantPirates');
	
	dropDownElem.disabled = chckBoxPirates.checked;	
}

function GuardAssignmentPanel_Hide()
{
	var panel = document.getElementById("GuardAssignmentPanel");			
	panel.style.display = 'none';
}

//////////////////////////////////////////////////////////////////////////////////////////
/// EmbassyPanel.inc
//////////////////////////////////////////////////////////////////////////////////////////

function EmbassyPanel_OnClick(element, event)
{
	event.cancelBubble = true;
}

function EmbassyPanel_Show()
{	
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{		
			var response = xmlhttp.responseText;
			var panel = document.getElementById("EmbassyPanel");
			panel.innerHTML = response;
			panel.style.display = 'block';
		}
	}

	var url = "responder.php?action=GetEmbassyPanel" + 
		"&rand=" + Math.random();
	
	xmlhttp.open("POST", url, true);
	xmlhttp.send(null);
}

function EmbassyPanel_CreateAlliance()
{
	var promptTextField = document.getElementById("EmbassyPanel_namePromptText");
	var promptText = promptTextField.value;
		
	var allianceName = "";
	
	while (allianceName.length == 0) 
	{
		allianceName = window.prompt(promptText, "").trim();
	}	
	
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{		
			var response = xmlhttp.responseText;
			
			if (response == "1") 
			{
                EmbassyPanel_Show();
            }
            else 
			{
                alert(response);
				document.location.reload();
            }
		}
	}

	var url = "responder.php?action=CreateAlliance" +
		"&allianceName=" + allianceName + 
		"&rand=" + Math.random();
	
	xmlhttp.open("POST", url, true);
	xmlhttp.send(null);
}

function EmbassyPanel_InvitePlayer()
{
	var inputElem = document.getElementById("EmbassyPanel_invitedLogin");
	var targetLogin = inputElem.value.trim();
	
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{		
			var response = xmlhttp.responseText;
			var lblElem = document.getElementById("EmbassyPanel_invitationResult");
			
			if (response == "1") 
			{
                inputElem.value = "";
				lblElem.style.color = "green";
				lblElem.innerHTML = document.getElementById("EmbassyPanel_inviteSuccessText").value;
            }
            else 
			{
				lblElem.style.color = "red";
                lblElem.innerHTML = response;
            }
		}
	}

	var url = "responder.php?action=InvitePlayerToAlliance" +
		"&invitedLogin=" + targetLogin + 
		"&rand=" + Math.random();
	
	xmlhttp.open("POST", url, true);
	xmlhttp.send(null);
}

function EmbassyPanel_AnswerInvitation(invitationId, accept, question)
{
	if (!confirm(question))
	{
		return;
	}
	
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{		
			var response = xmlhttp.responseText;
			
			if (response == "1") 
			{
                EmbassyPanel_Show();
            }
            else 
			{
				alert(response);
				document.location.reload();
            }
		}
	}

	var url = "responder.php?action=AnswerAllianceInvitations" +
		"&invitationId=" + invitationId + 
		"&accept=" + (accept ? "true" : "false") +
		"&rand=" + Math.random();
	
	xmlhttp.open("POST", url, true);
	xmlhttp.send(null);
}

function EmbassyPanel_LeaveAlliance(question)
{
	if (!confirm(question))
	{
		return;
	}
	
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{		
			var response = xmlhttp.responseText;
			
			if (response == "1") 
			{
                EmbassyPanel_Show();
            }
            else 
			{
				alert(response);
				document.location.reload();
            }
		}
	}

	var url = "responder.php?action=LeaveAlliance" +
		"&rand=" + Math.random();
	
	xmlhttp.open("POST", url, true);
	xmlhttp.send(null);
}

function EmbassyPanel_KickMember(memberId, question, promptText)
{
	if (!confirm(question))
	{
		return;
	}
	
	var reason = "";
	
	while (reason.length == 0) 
	{
		reason = window.prompt(promptText, "");
	}
	
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{		
			var response = xmlhttp.responseText;
			
			if (response == "1") 
			{
                EmbassyPanel_Show();
            }
            else 
			{
				alert(response);
				document.location.reload();
            }
		}
	}

	var url = "responder.php?action=KickAllianceMember" +
		"&memberId=" + memberId +
		"&reason=" + reason +
		"&rand=" + Math.random();
	
	xmlhttp.open("POST", url, true);
	xmlhttp.send(null);
}

function EmbassyPanel_Hide()
{
	var panel = document.getElementById("EmbassyPanel");			
	panel.style.display = 'none';
}

//////////////////////////////////////////////////////////////////////////////////////////
/// AllianceTransferPanel.inc
//////////////////////////////////////////////////////////////////////////////////////////

var AllianceTransfer_onLoadOnce = null;
var AllianceTransfer_onHideOnce = null;

function AllianceTransferPanel_OnClick(element, event)
{
	event.cancelBubble = true;
}

function AllianceTransferPanel_Show()
{	
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{		
			var response = xmlhttp.responseText;
			var panel = document.getElementById("AllianceTransferPanel");
			panel.innerHTML = response;
			
			if (AllianceTransfer_onLoadOnce != null)
			{
				AllianceTransfer_onLoadOnce();
				AllianceTransfer_onLoadOnce = null;
			}
			
			panel.style.display = 'block';
		}
	}

	var url = "responder.php?action=GetAllianceTransferPanel" + 
		"&rand=" + Math.random();
	
	xmlhttp.open("POST", url, true);
	xmlhttp.send(null);
}

function AllianceTransferPanel_DonateMoney(questionFormat)
{
	var amount = document.getElementById("AllianceTransferPanel_donateMoneyAmount").value.trim();
	
	var recieverElem = document.getElementById("AllianceTransferPanel_donateMoneyReciever");
	var reciever = recieverElem.value;
	var recieverName = recieverElem.options[recieverElem.selectedIndex].text;
	
	if (amount.charAt(0) == "$")
	{
		amount = amount.substring(1);
	}
	
	var resElem = document.getElementById("AllianceTransferPanel_donateMoneyResultLbl");
	resElem.innerHTML = "";
	
	if (!IsPositiveIntegerString(amount))
	{
		resElem.style.color = "red";
		TranslateTerm("ALLIANCE_MONEY_NOT_NUMBER", resElem);
		return;
	}
	
	amount = parseInt(amount);
	
	if (amount > ALLIANCE_MONEY_DONATE_MAX)
	{
		resElem.style.color = "red";
		TranslateTerm("ALLIANCE_MONEY_TOO_HIGH", resElem, "", ALLIANCE_MONEY_DONATE_MAX);
		return;
	}
	
	if (!confirm(sprintf(questionFormat, amount, recieverName)))
	{
		return;
	}
	
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{		
			var response = xmlhttp.responseText;
			
			if (response == "1") 
			{
                //inputElem.value = "$0";
				resElem.style.color = "green";
				resElem.innerHTML =  document.getElementById('donateMoneySuccessText').value;
            }
            else 
			{
				resElem.style.color = "red";
                resElem.innerHTML = response;
            }
		}
	}

	var url = "responder.php?action=AllianceDonateMoney" +
		"&amount=" + amount + 
		"&recieverLogin=" + reciever +
		"&rand=" + Math.random();
	
	xmlhttp.open("POST", url, true);
	xmlhttp.send(null);	
}

function AllianceTransferPanel_DonateGuard_RecieverChange(ddlElem)
{
	if (ddlElem.value == -1)
	{
		ddlElem.previousSibling.previousSibling.disabled = true;
		ddlElem.previousSibling.previousSibling.style.color = "gray";
	}
	else
	{
		ddlElem.previousSibling.previousSibling.disabled = false;
		ddlElem.previousSibling.previousSibling.style.color = "black";
	}
	
	var listElem = document.getElementById("AllianceTransferPanel_donateGuardList");
	var items = AllianceTransferPanel_GetDonateGuardsItems();
	
	var lastItem = items[items.length - 1];
	var recieverSelectElem = lastItem.childNodes[3];
	
	if (recieverSelectElem.value == -1)
	{
		for (var j = 2; j <= items.length; j++)
		{
			var item = items[items.length - j];
			recieverSelectElem = item.childNodes[3];
			
			if (recieverSelectElem.value != -1)
			{
				break;
			}
			
			listElem.removeChild(items[items.length - j + 1]);			
		}
	}
	else
	{		
		var cloneItem = lastItem.cloneNode(true);
		recieverSelectElem = cloneItem.childNodes[3];	
		recieverSelectElem.selectedIndex = 0;
		cloneItem.childNodes[1].disabled = true;
		cloneItem.childNodes[1].style.color = "gray";
		listElem.appendChild(cloneItem);
	}
}

function AllianceTransferPanel_ExtractGuardDonates()
{
	var items = AllianceTransferPanel_GetDonateGuardsItems();
	
	var res = new Array();
	
	for (var key in items)
	{
		var item = items[key];
		var recieverDdlElem = item.childNodes[3];
		
		if (recieverDdlElem.value == -1)
		{
			continue;
		}
		
		var guardDdlElem = item.childNodes[1];
		
		if (res[guardDdlElem.value] != null)
		{
			continue;
		}
		
		res[guardDdlElem.value] = recieverDdlElem.value;
	}
	
	return res;
}

function AllianceTransferPanel_DonateGuards(questionFormat)
{
	var donates = AllianceTransferPanel_ExtractGuardDonates();
	
	var resElem = document.getElementById("AllianceTransferPanel_donateGuardsResultLbl");
	resElem.innerHTML = "";
	
	if (donates.length == 0)
	{
		resElem.style.color = "red";
		TranslateTerm("ALLIANCE_GUARDS_NONE_SELECTED", resElem, "", "");
		return;
	}
	
	var commString = "";
	var count = 0;
	
	for (var key in donates) 
	{
		commString += key + ";" + donates[key] + "%"; 
		count++;
	}
		
	if (!confirm(sprintf(questionFormat, count)))
	{
		return;
	}
		
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{		
			var response = xmlhttp.responseText;
			
			
			
			
			if (isFinite(response)) 
			{
				var doneCount = parseInt(response);
				
				if (doneCount == count) 
				{
					AllianceTransfer_onLoadOnce = function()
					{
						var resElem = document.getElementById("AllianceTransferPanel_donateGuardsResultLbl");
						resElem.style.color = "green";
						resElem.innerHTML = document.getElementById('AllianceTransferPanel_donateGuardsSuccessText').value;
					}
					
				}
				else
				{
					AllianceTransfer_onLoadOnce = function()
					{
						var resElem = document.getElementById("AllianceTransferPanel_donateGuardsResultLbl");
						resElem.style.color = "orange";
						resElem.innerHTML = sprintf(document.getElementById('AllianceTransferPanel_donateGuardsPartialResText').value, doneCount, count);
					}
				}
				
				AllianceTransferPanel_Show();
				
				AllianceTransfer_onHideOnce = function()
				{
					document.location.reload();
				}
            }
            else 
			{
				resElem.style.color = "red";
                resElem.innerHTML = response;
            }
		}
	}

	var url = "responder.php?action=AllianceDonateGuards" +
		"&donates=" + commString + 
		"&rand=" + Math.random();
	
	xmlhttp.open("POST", url, true);
	xmlhttp.send(null);	
}

function AllianceTransferPanel_GetDonateGuardsItems()
{
	var listElem = document.getElementById("AllianceTransferPanel_donateGuardList");
	var items = new Array();
	
	var i = 0;
	for (var key in listElem.childNodes)
	{
		var item = listElem.childNodes[key];
		
		if (item == "[object HTMLDivElement]")
		{
			items[i] = item;
			i++;
		}
	} 
	
	return items;
}

function AllianceTransferPanel_Hide()
{
	var panel = document.getElementById("AllianceTransferPanel");			
	panel.style.display = 'none';
	
	if (AllianceTransfer_onHideOnce != null)
	{
		AllianceTransfer_onHideOnce();
		AllianceTransfer_onHideOnce = null;
	}
}

//////////////////////////////////////////////////////////////////////////////////////////
/// GalaxyMap.inc
//////////////////////////////////////////////////////////////////////////////////////////

var GalaxyMap_DEFAULT_BORDER_COLOR = "White";
var GalaxyMap_ROUTE_BORDER_COLOR = "Yellow";
var GalaxyMap_SELECTED_BORDER_COLOR = "Yellow";
var GalaxyMap_REMOVE_BORDER_COLOR = "Red";
var GalaxyMap_INIT_BORDER_COLOR = "Purple";
var GalaxyMap_FINAL_BORDER_COLOR = "Orange";

var GalaxyMap_DEFAULT_BORDER_WIDTH = 2;
var GalaxyMap_HIGHLIGHT_BORDER_WIDTH = 4;

var GalaxyMap_LINK_COLOR = "Cyan";
var GalaxyMap_LINK_WIDTH = 6;

var GalaxyMap_route = new Array();
var GalaxyMap_lines = new Array();
var GalaxyMap_initSystem = null;
var GalaxyMap_finalSystem = null;
var GalaxyMap_selectedSystem = null;
var GalaxyMap_mode = "browse";

function GalaxyMap_OnClick(element, event)
{
	event.cancelBubble = true;
	
	if (GalaxyMap_selectedSystem != null)
	{
		SetElementBorderWidth(GalaxyMap_selectedSystem, 0);
		GalaxyMap_selectedSystem = null;					
	}
	
	GalaxyMap_ActionBtnUpdateVisibility();
}

function GalaxyMap_Show(shipId, deliveryId, targetSystemId)
{	
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{		
			var response = xmlhttp.responseText;
			var panel = document.getElementById("GalaxyMap");
			panel.innerHTML = response;			
			panel.style.display = 'block';
			//alert(response);
			
			GalaxyMap_route = new Array();
			GalaxyMap_lines = new Array();
			
			GalaxyMap_selectedSystem = null;
			GalaxyMap_initSystem = document.getElementById(document.getElementById("GalaxyMap_initSystem").value);
			GalaxyMap_finalSystem = document.getElementById(document.getElementById("GalaxyMap_finalSystem").value);
			
			if (GalaxyMap_initSystem == null) 
			{
				GalaxyMap_mode = "browse";
			}
			else 
			{
				GalaxyMap_AddSystemToRoute(GalaxyMap_initSystem);
				SetElementBorderWidth(GalaxyMap_initSystem, GalaxyMap_HIGHLIGHT_BORDER_WIDTH);
				GalaxyMap_initSystem.style.borderColor = GalaxyMap_INIT_BORDER_COLOR;
					
				if (GalaxyMap_finalSystem == null) 
				{
					GalaxyMap_mode = "nav_free";
				}
				else 
				{
					GalaxyMap_mode = "nav_target";
					SetElementBorderWidth(GalaxyMap_finalSystem, GalaxyMap_HIGHLIGHT_BORDER_WIDTH);
					GalaxyMap_finalSystem.style.borderColor = GalaxyMap_FINAL_BORDER_COLOR;
				}
			}						
		}
	}

	var url = "responder.php?action=GetGalaxyMap" +
		"&screenWidth=" + screenWidth +
		"&screenHeight=" + screenHeight + 
		(shipId ? "&shipId=" + shipId : "") +
		(deliveryId ? "&deliveryId=" + deliveryId : "") +
		(targetSystemId ? "&targetSystemId=" + targetSystemId : "") +
		"&rand=" + Math.random();
	
	xmlhttp.open("POST", url, true);
	xmlhttp.send(null);
}

function GalaxyMap_IsSystemInRoute(systemElem)
{
	for (var i = 0; i < GalaxyMap_route.length; i++)
	{
		if (GalaxyMap_route[i] == systemElem)
		{
			return true;
		}
	}
	
	return false;
}

function GalaxyMap_AddSystemToRoute(systemElem)
{
	if (GalaxyMap_route.length > 0) 
	{
		if (!GalaxyMap_IsSystemLinkLegal(GalaxyMap_route[GalaxyMap_route.length - 1], systemElem)) 
		{
			return false;
		}
		
		if (GalaxyMap_route[GalaxyMap_route.length - 1] == GalaxyMap_finalSystem)
		{
			return false;
		}
	}
	
	GalaxyMap_route[GalaxyMap_route.length] = systemElem;
	
	if (GalaxyMap_route.length <= 1)
	{
		return true;
	}
	
	var prevSys = GalaxyMap_route[GalaxyMap_route.length - 2];
	
	var line = GalaxyMap_CreateLinkBetweenSystems(prevSys, systemElem);
	var lineDiv = document.getElementById("GalaxyMap_lineDiv");
	lineDiv.appendChild(line);
	//alert(lineDiv.innerHTML);
	GalaxyMap_lines.push(line);
	
	return true;
}

function GalaxyMap_RemoveLastSystemFromRoute()
{
	GalaxyMap_route.pop();
	
	if (GalaxyMap_lines.length > 0)
	{
		var lineDiv = document.getElementById("GalaxyMap_lineDiv");
		lineDiv.removeChild(GalaxyMap_lines.pop());	
	}	
}

function GalaxyMap_IsSystemLinkLegal(sysAElem, sysBElem)
{
	var sysBId = document.getElementById(sysBElem.id + "_id").value;
	
	var connsA = document.getElementById(sysAElem.id + "_connectedSystems").value;
	connsA = connsA.split(";");
	
	for (var key in connsA)
	{
		if (connsA[key] == sysBId)
		{
			return true;
		}
	}
	
	return false;
}

function GalaxyMap_CreateLinkBetweenSystems(sysAElem, sysBElem)
{
	var leftA = parseFloat(sysAElem.style.left);
	var topA = parseFloat(sysAElem.style.top);
	var widthA = parseFloat(sysAElem.style.width);
	var heightA = parseFloat(sysAElem.style.height);
	
	var leftB = parseFloat(sysBElem.style.left);
	var topB = parseFloat(sysBElem.style.top);
	var widthB = parseFloat(sysBElem.style.width);
	var heightB = parseFloat(sysBElem.style.height);
	
	var x0 = leftA + widthA / 2;
	var y0 = topA + heightA / 2;
	var x1 = leftB + widthB / 2;
	var y1 = topB + heightB / 2;
	
	var line = DrawLine(x0, y0, x1, y1, sysAElem.id + "_to_" + sysBElem.id, GalaxyMap_LINK_COLOR, GalaxyMap_LINK_WIDTH);
	return line;
}

function GalaxyMap_SystemOnClick(elem, event)
{
	if (event) 
	{
		event.cancelBubble = true;
	}
	
	if (GalaxyMap_mode == "browse")
	{
		if (GalaxyMap_selectedSystem != null)
		{
			SetElementBorderWidth(GalaxyMap_selectedSystem, 0);
		}
		GalaxyMap_selectedSystem = elem;
		SetElementBorderWidth(elem, GalaxyMap_HIGHLIGHT_BORDER_WIDTH);		
		elem.style.borderColor = GalaxyMap_SELECTED_BORDER_COLOR;	
	}
	else if (!GalaxyMap_IsSystemInRoute(elem)) 
	{
		if (!GalaxyMap_AddSystemToRoute(elem))
		{
			return;
		}
		SetElementBorderWidth(elem, GalaxyMap_HIGHLIGHT_BORDER_WIDTH);		
		elem.style.borderColor = GalaxyMap_REMOVE_BORDER_COLOR;		
	}
	else
	{
		if (elem == GalaxyMap_initSystem)
		{
			return;
		}
		
		if (GalaxyMap_route[GalaxyMap_route.length - 1] == elem)
		{
			GalaxyMap_RemoveLastSystemFromRoute();
			GalaxyMap_SystemOnMouseOut(elem, event);
		}
	}
	
	GalaxyMap_ActionBtnUpdateVisibility();
}

function GalaxyMap_SystemOnDoubleClick(elem, event)
{
	event.cancelBubble = false;
	
	if (GalaxyMap_mode != "browse")
	{
		return;
	}
	
	var systemId = document.getElementById(elem.id + "_id").value;
	WormHoleGraphic_GoToSystem(systemId);
}

function GalaxyMap_SystemOnMouseOver(elem, event)
{
	SetElementBorderWidth(elem, GalaxyMap_HIGHLIGHT_BORDER_WIDTH);
	
	if (GalaxyMap_route[GalaxyMap_route.length - 1] == elem)
	{
		elem.style.borderColor = GalaxyMap_REMOVE_BORDER_COLOR;
	}
	else
	{
		elem.style.borderColor = GalaxyMap_DEFAULT_BORDER_COLOR;
	}
}

function GalaxyMap_SystemOnMouseOut(elem, event)
{
	if (elem == GalaxyMap_selectedSystem) 
	{
		elem.style.borderColor = GalaxyMap_SELECTED_BORDER_COLOR;
	}
	else if (elem == GalaxyMap_initSystem)
	{
		elem.style.borderColor = GalaxyMap_INIT_BORDER_COLOR;
	}
	else if (elem == GalaxyMap_finalSystem)
	{
		elem.style.borderColor = GalaxyMap_FINAL_BORDER_COLOR;
	}
	else if (!GalaxyMap_IsSystemInRoute(elem)) 
	{
		SetElementBorderWidth(elem, 0);		
	}
	else
	{
		elem.style.borderColor = GalaxyMap_ROUTE_BORDER_COLOR;
	}	
}

function GalaxyMap_NavigateShip()
{
	if (GalaxyMap_mode != "nav_free" && GalaxyMap_mode != "nav_target")
	{
		return false;
	}
	
	if (GalaxyMap_mode == "nav_free" && GalaxyMap_route.length <= 1)
	{
		return false;
	}
	
	if (GalaxyMap_mode == "nav_target" && GalaxyMap_route[GalaxyMap_route.length - 1] != GalaxyMap_finalSystem)
	{
		return false;
	}
	
	var shipId = document.getElementById("GalaxyMap_shipId").value;
	var deliveryId = document.getElementById("GalaxyMap_deliveryId").value;
	
	var pathA = "";
	
	for (var i = 1; i < GalaxyMap_route.length; i++)
	{
		var systemId = document.getElementById(GalaxyMap_route[i].id + "_id").value;
		pathA += systemId;
		
		if (i != GalaxyMap_route.length - 1)
		{
			pathA += ";";
		}
	}
	
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{		
			var response = xmlhttp.responseText;
			
			if (response == 1)
			{
				if (deliveryId.length > 0)
				{
					//alert("ShipSelectionPanel_DeliverLocal(shipId, deliveryId, true);")
					ShipSelectionPanel_DeliverLocal(shipId, deliveryId, true);
				}
				else if (GalaxyMap_finalSystem != null)
				{
					//alert("MenuPanel_FinishDeliveriesLocal(shipId);");
					MenuPanel_FinishDeliveriesLocal(shipId);
				}
				//alert(sprintf("deliveryId = %s; ", deliveryId) + GalaxyMap_finalSystem);
			}
			else
			{
				alert(response);
			}
			
			GalaxyMap_Hide();
		}
	}

	var url = "responder.php?action=NavigateShip" + 
		"&shipId=" + shipId +
		"&pathA=" + pathA +
		"&rand=" + Math.random();
	
	xmlhttp.open("POST", url, true);
	xmlhttp.send(null);
}

function GalaxyMap_ActionBtnOnClick(elem, event)
{
	event.cancelBubble = true;
	
	if (GalaxyMap_mode == "browse" && GalaxyMap_selectedSystem != null)
	{
		var systemId = document.getElementById(GalaxyMap_selectedSystem.id + "_id").value;
		WormHoleGraphic_GoToSystem(systemId);
	}
	else if (GalaxyMap_mode == "nav_free" && GalaxyMap_route.length > 1)
	{
		GalaxyMap_NavigateShip();
	}
	else if (GalaxyMap_mode == "nav_target" && GalaxyMap_route[GalaxyMap_route.length - 1] == GalaxyMap_finalSystem)
	{
		GalaxyMap_NavigateShip();
	}
}

function GalaxyMap_ActionBtnUpdateVisibility()
{
	var btnElem = document.getElementById("GalaxyMap_actionBtn");
	
	switch (GalaxyMap_mode)
	{
		case "browse":
			if (GalaxyMap_selectedSystem != null)
			{
				btnElem.style.display = "block";
			}
			else
			{
				btnElem.style.display = "none";
			}
			break;
		case "nav_free":
			if (GalaxyMap_route.length > 1)
			{
				btnElem.style.display = "block";
			}
			else
			{
				btnElem.style.display = "none";
			}
			break;
		case "nav_target":
			if (GalaxyMap_route[GalaxyMap_route.length - 1] == GalaxyMap_finalSystem)
			{
				btnElem.style.display = "block";
			}
			else
			{
				btnElem.style.display = "none";
			}
			break;
		default:
			btnElem.style.display = "none";
			break;
	}
}

function GalaxyMap_Hide()
{
	var panel = document.getElementById("GalaxyMap");			
	panel.style.display = 'none';
}

//////////////////////////////////////////////////////////////////////////////////////////
/// IntroScreen.inc
//////////////////////////////////////////////////////////////////////////////////////////

function IntroScreen_ShowPanel(panelId, event)
{
	event.cancelBubble = true;
	
	var showPanel = document.getElementById(panelId);
	
	var allPanels = document.getElementsByName("IntroScreen_textPanel");
	
	for (var key in allPanels)
	{
		var panel = allPanels[key];
		
		if (panel.tagName == "DIV" && panel != showPanel)
		{
			panel.style.display = "none";	
		}
	}	
	
	showPanel.style.display = "block";
}
