/**
 * @author keni
 */

//////////////////////////////////////////////////////////////////////////////////////////
/// MessagePanel.inc
//////////////////////////////////////////////////////////////////////////////////////////

function MessagePanel_OnClick(event)
{
	event.cancelBubble = true;
}

function MessagePanel_ShowNewMessage(reciever)
{	
	if (reciever == null)
	{
		reciever = "";
	}
	
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{
			var panel = document.getElementById("MessagePanel");		
			var response = xmlhttp.responseText;
			panel.innerHTML = response;
			panel.style.display = 'block';
		}
	}

	var url = "responder.php?action=GetMessagePanel" + 
		"&mode=new" +
		"&reciever=" + reciever +
		"&rand=" + Math.random();
	
	xmlhttp.open("POST", url, true);
	xmlhttp.send(null);
}

function MessagePanel_ShowReadMessage(messageId)
{	
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{
			var panel = document.getElementById("MessagePanel");		
			var response = xmlhttp.responseText;
			panel.innerHTML = response;
			panel.style.display = 'block';
		}
	}

	var url = "responder.php?action=GetMessagePanel" + 
		"&mode=read" +
		"&messageId=" + messageId +
		"&rand=" + Math.random();
	
	xmlhttp.open("POST", url, true);
	xmlhttp.send(null);
}

function MessagePanel_ShowList(sortKey, sortOrder)
{	
	if (sortKey == null)
	{
		sortKey = "date";
	}
	
	if (sortOrder == null)
	{
		sortOrder = "desc";
	}
	
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{
			var panel = document.getElementById("MessagePanel");		
			var response = xmlhttp.responseText;
			panel.innerHTML = response;
			panel.style.display = 'block';
		}
	}

	var url = "responder.php?action=GetMessagePanel" + 
		"&mode=list" +
		"&sortKey=" + sortKey +
		"&sortOrder=" + sortOrder +
		"&rand=" + Math.random();
	
	xmlhttp.open("POST", url, true);
	xmlhttp.send(null);
}

function MessagePanel_SendNewMessage(formId)
{
	var form = document.getElementById(formId);
	if (!form)
	{
		return false;
	}
	
	var allOk = true;
	if (!ValidateUserLogin(formId + "_reciever", true))
	{
		allOk = false;
	}
	
	if (!ValidateSubject(formId + "_subject"))
	{
		allOk = false;
	}
	
	if (!allOk)
	{
		return false;
	}
	
	var recieverInput = document.getElementById(formId + "_reciever");
	var subjectInput = document.getElementById(formId + "_subject");
	var textBodyTA = document.getElementById(formId + "_textbody");
	
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{
			var response = xmlhttp.responseText;
			MessagePanel_SendNewMessageAnswer(response, formId)
		}
	}
	
	var url = "responder.php?action=SendNewMessage" + 
		"&reciever=" + recieverInput.value +
		"&subject=" + subjectInput.value +
		"&textbody=" + textBodyTA.value +
		"&rand=" + Math.random();
		
	xmlhttp.open("POST", url, true);
	xmlhttp.send(null);
}

function MessagePanel_SendNewMessageAnswer(response, formId)
{
	var panel = document.getElementById("MessagePanel");
	
	var flag = response.charAt(0);
	
	if (flag == '0')
	{
		alert("Message couldn't have been sent.");
		return;
	}
	
	if (flag == '2') 
	{
		var recieverErrorLabel = document.getElementById(formId + "_reciever_error");
		TranslateTerm("RECIEVER_NOT_EXIST", recieverErrorLabel, "", "");
		return;
	}
	
	panel.innerHTML = response;
}

var SUBJECT_MIN_LENGTH = 1;
var SUBJECT_MAX_LENGTH = 255;

function ValidateSubject(inputId)
{
	var input = document.getElementById(inputId);
	var error = document.getElementById(inputId + "_error");
	error.innerHTML = "";
	
	var subject = input.value;
	
	if (subject.length < SUBJECT_MIN_LENGTH)
	{
		TranslateTerm("SUBJECT_MIN_LENGTH", error, "", ".");
		return false;
	}
	
	if (subject.length > SUBJECT_MAX_LENGTH)
	{
		TranslateTerm("SUBJECT_MAX_LENGTH", error, "", " " + SUBJECT_MAX_LENGTH + ".");
		return false;
	}
	
	return true;
}

function MessagePanel_DeleteMessage(messageId)
{
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{
			var panel = document.getElementById("MessagePanel");		
			var response = xmlhttp.responseText;
			panel.innerHTML = response;
			panel.style.display = 'block';
		}
	}

	var url = "responder.php?action=DeleteMessage" + 
		"&messageId=" + messageId
		"&rand=" + Math.random();
	
	xmlhttp.open("POST", url, true);
	xmlhttp.send(null);
}

function MessagePanel_Hide()
{
	var panel = document.getElementById("MessagePanel");			
	panel.style.display = 'none';
}