// ////////////////////////////////////////////////////////////////////////////////////////
// / LoginPanel.inc
// ////////////////////////////////////////////////////////////////////////////////////////

function EnterLoginPanelInput(defaultText, event) 
{
	var textbox = event.target;
	
	if (textbox.value == defaultText)
	{
		textbox.value = "";
		textbox.className = 'LoginPanel_input';
	}
}

function LeaveLoginPanelInput(defaultText, event) 
{
	var textbox = event.target;
	
	var text = textbox.value;
	text = text.replace(/ /g, "");
	if (text.length != 0) 
	{
		return;
	}
	
	textbox.value = defaultText;
	textbox.className = 'LoginPanel_inputGray';
}

function Login(loginPanelID)
{
	var loginPanel = document.getElementById(loginPanelID);
	var loginTextbox = document.getElementById(loginPanelID + "_Form_login");
	var passwordTextbox = document.getElementById(loginPanelID + "_Form_password");
	
	var login = loginTextbox.value;
	var password = md5(passwordTextbox.value);
	
	var panelWidthString = loginPanel.style.width; 
	var panelWidth = panelWidthString.substr(0, panelWidthString.length - 2);
	
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{
			var response = xmlhttp.responseText;
			if (response.substring(0, 1) == '0')
			{
				loginPanel.innerHTML = response.substring(1, response.length);
			}
			else
			{
				window.location.reload();
			}
		}
	}

	var url = "responder.php?action=login" + 
		"&login=" + login +
		"&password=" + password +
		"&width=" + panelWidth + 
		"&panelId=" + loginPanelID + 
		"&rand=" + Math.random();
	
	xmlhttp.open("POST", url, true);
	xmlhttp.send(null);
}

function Logout()
{
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{
			document.location.reload();			
		}
	}
	
	var url = "responder.php?action=logout" + 
		"&rand=" + Math.random();

	xmlhttp.open("POST", url, true);
	xmlhttp.send(null);
}

function LoginPanel_ForgotPassword()
{
	document.location = "accounts.php?action=forgot";
}

// ////////////////////////////////////////////////////////////////////////////////////////
// / LanguageSelector.inc
// ////////////////////////////////////////////////////////////////////////////////////////

function SetLanguage(languageCode)
{
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{
			document.location.reload();
		}
	}

	var url = "responder.php?action=SetLanguage" + 
		"&languageCode=" + languageCode +
		"&rand=" + Math.random();
	xmlhttp.open("GET", url, true);
	xmlhttp.send(null);
}

// ////////////////////////////////////////////////////////////////////////////////////////
// / UserDetailForm.inc
// ////////////////////////////////////////////////////////////////////////////////////////

function UserDetailForm_DeletePlayer(formId)
{
	var promptInput = document.getElementById(formId + '_deletePromptText');
	
	if (!confirm(promptInput.value))
	{
		return;
	}
	
	var actionInput = document.getElementById(formId + '_action');
	actionInput.value = "deletePlayer";
	
	var form = document.getElementById(formId);
	form.submit();
}

function ValidateUserDetailForm(formId, mode)
{
	var form = document.getElementById(formId);
	if (!form)
	{
		return false;
	}
	
	var allOk = true;
	if (mode != "passwordGenerate" && mode != "editUser" && !ValidateUserLogin(formId + "_login"))
	{
		allOk = false;
	}
	
	if (mode != "editUser" && !ValidateUserEmail(formId + "_email"))
	{
		allOk = false;
	}
	
	if (mode != "passwordGenerate" && !ValidateUserPassword(formId + "_password", mode))
	{
		allOk = false;
	}
	
	if (!ValidateUserNick(formId + "_nick"))
	{
		allOk = false;
	}
	
	if (!allOk)
	{
		return false;
	}
	
	if (mode == "editUser")
	{
		HashPassword(formId + "_password_old");
	}
	
	if (mode != "passwordGenerate") 
	{
		HashPassword(formId + "_password");
		HashPassword(formId + "_password2");
	}
	
	//var form = document.getElementById(formId);
	//form.target = window.location.pathname;
	
	return true;
}

var LOGIN_MIN_LENGTH = 5;
var LOGIN_MAX_LENGTH = 30;

function ValidateUserLogin(inputId)
{	
	var input = document.getElementById(inputId);
	var error = document.getElementById(inputId + "_error");
	error.innerHTML = "";
	
	var login = input.value;
	login = login.replace(/ /g, "");
	
	if (login.length < LOGIN_MIN_LENGTH)
	{
		TranslateTerm("LOGIN_MIN_LENGTH", error, "", " " + LOGIN_MIN_LENGTH + ".");
		return false;
	}
	
	if (login.length > LOGIN_MAX_LENGTH)
	{
		TranslateTerm("LOGIN_MAX_LENGTH", error, "", " " + LOGIN_MAX_LENGTH + ".");
		return false;
	}
	
	input.value = login;
	return true;
}

function ValidateUserEmail(inputId)
{
	var input = document.getElementById(inputId);
	var error = document.getElementById(inputId + "_error");
	error.innerHTML = "";
	
	var email = input.value;
	
	if (email.length <= 0)
	{
		TranslateTerm("EMAIL_NOT_FILLED", error);
		return false;
	}
	
	var reg = /^([A-Za-z0-9_\-\.])+\@([A-Za-z0-9_\-\.])+\.([A-Za-z]{2,4})$/;
	
	if(reg.test(email) == false) 
	{
		TranslateTerm("EMAIL_INVALID", error);
		return false;
	}
	
	return true;
}

var PASSWORD_MIN_LENGTH = 5;
var PASSWORD_MAX_LENGTH = 32;

function ValidateUserPassword(inputId, mode)
{
	var input = document.getElementById(inputId);
	var error = document.getElementById(inputId + "_error");
	error.innerHTML = "";
	
	var input2 = document.getElementById(inputId + "2");
	var error2 = document.getElementById(inputId + "2_error");
	error2.innerHTML = "";
	
	var password = input.value;
	var password2 = input2.value;
	
	if (mode == 'editUser' && password.length == 0 && password2.length == 0)
	{
		return true;
	}
	
	if (password.length < PASSWORD_MIN_LENGTH)
	{
		TranslateTerm("PASSWORD_MIN_LENGTH", error, "", " " + PASSWORD_MIN_LENGTH + ".");
		return false;
	}
	
	if (password.length > PASSWORD_MAX_LENGTH)
	{
		TranslateTerm("PASSWORD_MAX_LENGTH", error, "", " " + PASSWORD_MAX_LENGTH + ".");
		return false;
	}
	
	if (password != password2)
	{
		TranslateTerm("PASSWORD_MISSMATCH", error2);
		return false;
	} 
	
	return true;
}

function ValidateUserNick(inputId)
{
	var input = document.getElementById(inputId);
	var error = document.getElementById(inputId + "_error");
	error.innerHTML = "";
	
	var nick = input.value;
	
	return true;
}

function HashPassword(inputId)
{
	var input = document.getElementById(inputId);
	
	if (input.value.length == 0)
	{
		return;
	}
	
	input.value = md5(input.value);
}