/**
 * Gets browser independent AJAX object.
 * 
 * @return AJAX object
 */
function GetXMLHTTP()
{
	if (window.XMLHttpRequest)
  	{
  		// code for IE7+, Firefox, Chrome, Opera, Safari
  		return new XMLHttpRequest();
  	}
	else if (window.ActiveXObject)
  	{
  	// code for IE6, IE5
  		 return new ActiveXObject("Microsoft.XMLHTTP");
  	}
	else
  	{
  		alert("Your browser does not support XMLHTTP!");
  		return null;
  	}
}

/**
 * 
 * MD5 (Message-Digest Algorithm) http://www.webtoolkit.info/
 * 
 */
function md5(string) {
 
	function RotateLeft(lValue, iShiftBits) {
		return (lValue<<iShiftBits) | (lValue>>>(32-iShiftBits));
	}
 
	function AddUnsigned(lX,lY) {
		var lX4,lY4,lX8,lY8,lResult;
		lX8 = (lX & 0x80000000);
		lY8 = (lY & 0x80000000);
		lX4 = (lX & 0x40000000);
		lY4 = (lY & 0x40000000);
		lResult = (lX & 0x3FFFFFFF)+(lY & 0x3FFFFFFF);
		if (lX4 & lY4) {
			return (lResult ^ 0x80000000 ^ lX8 ^ lY8);
		}
		if (lX4 | lY4) {
			if (lResult & 0x40000000) {
				return (lResult ^ 0xC0000000 ^ lX8 ^ lY8);
			} else {
				return (lResult ^ 0x40000000 ^ lX8 ^ lY8);
			}
		} else {
			return (lResult ^ lX8 ^ lY8);
		}
 	}
 
 	function F(x,y,z) { return (x & y) | ((~x) & z); }
 	function G(x,y,z) { return (x & z) | (y & (~z)); }
 	function H(x,y,z) { return (x ^ y ^ z); }
	function I(x,y,z) { return (y ^ (x | (~z))); }
 
	function FF(a,b,c,d,x,s,ac) {
		a = AddUnsigned(a, AddUnsigned(AddUnsigned(F(b, c, d), x), ac));
		return AddUnsigned(RotateLeft(a, s), b);
	};
 
	function GG(a,b,c,d,x,s,ac) {
		a = AddUnsigned(a, AddUnsigned(AddUnsigned(G(b, c, d), x), ac));
		return AddUnsigned(RotateLeft(a, s), b);
	};
 
	function HH(a,b,c,d,x,s,ac) {
		a = AddUnsigned(a, AddUnsigned(AddUnsigned(H(b, c, d), x), ac));
		return AddUnsigned(RotateLeft(a, s), b);
	};
 
	function II(a,b,c,d,x,s,ac) {
		a = AddUnsigned(a, AddUnsigned(AddUnsigned(I(b, c, d), x), ac));
		return AddUnsigned(RotateLeft(a, s), b);
	};
 
	function ConvertToWordArray(string) {
		var lWordCount;
		var lMessageLength = string.length;
		var lNumberOfWords_temp1=lMessageLength + 8;
		var lNumberOfWords_temp2=(lNumberOfWords_temp1-(lNumberOfWords_temp1 % 64))/64;
		var lNumberOfWords = (lNumberOfWords_temp2+1)*16;
		var lWordArray=Array(lNumberOfWords-1);
		var lBytePosition = 0;
		var lByteCount = 0;
		while ( lByteCount < lMessageLength ) {
			lWordCount = (lByteCount-(lByteCount % 4))/4;
			lBytePosition = (lByteCount % 4)*8;
			lWordArray[lWordCount] = (lWordArray[lWordCount] | (string.charCodeAt(lByteCount)<<lBytePosition));
			lByteCount++;
		}
		lWordCount = (lByteCount-(lByteCount % 4))/4;
		lBytePosition = (lByteCount % 4)*8;
		lWordArray[lWordCount] = lWordArray[lWordCount] | (0x80<<lBytePosition);
		lWordArray[lNumberOfWords-2] = lMessageLength<<3;
		lWordArray[lNumberOfWords-1] = lMessageLength>>>29;
		return lWordArray;
	};
 
	function WordToHex(lValue) {
		var WordToHexValue="",WordToHexValue_temp="",lByte,lCount;
		for (lCount = 0;lCount<=3;lCount++) {
			lByte = (lValue>>>(lCount*8)) & 255;
			WordToHexValue_temp = "0" + lByte.toString(16);
			WordToHexValue = WordToHexValue + WordToHexValue_temp.substr(WordToHexValue_temp.length-2,2);
		}
		return WordToHexValue;
	};
 
	function Utf8Encode(string) {
		string = string.replace(/\r\n/g,"\n");
		var utftext = "";
 
		for (var n = 0; n < string.length; n++) {
 
			var c = string.charCodeAt(n);
 
			if (c < 128) {
				utftext += String.fromCharCode(c);
			}
			else if((c > 127) && (c < 2048)) {
				utftext += String.fromCharCode((c >> 6) | 192);
				utftext += String.fromCharCode((c & 63) | 128);
			}
			else {
				utftext += String.fromCharCode((c >> 12) | 224);
				utftext += String.fromCharCode(((c >> 6) & 63) | 128);
				utftext += String.fromCharCode((c & 63) | 128);
			}
 
		}
 
		return utftext;
	};
 
	var x=Array();
	var k,AA,BB,CC,DD,a,b,c,d;
	var S11=7, S12=12, S13=17, S14=22;
	var S21=5, S22=9 , S23=14, S24=20;
	var S31=4, S32=11, S33=16, S34=23;
	var S41=6, S42=10, S43=15, S44=21;
 
	string = Utf8Encode(string);
 
	x = ConvertToWordArray(string);
 
	a = 0x67452301; b = 0xEFCDAB89; c = 0x98BADCFE; d = 0x10325476;
 
	for (k=0;k<x.length;k+=16) {
		AA=a; BB=b; CC=c; DD=d;
		a=FF(a,b,c,d,x[k+0], S11,0xD76AA478);
		d=FF(d,a,b,c,x[k+1], S12,0xE8C7B756);
		c=FF(c,d,a,b,x[k+2], S13,0x242070DB);
		b=FF(b,c,d,a,x[k+3], S14,0xC1BDCEEE);
		a=FF(a,b,c,d,x[k+4], S11,0xF57C0FAF);
		d=FF(d,a,b,c,x[k+5], S12,0x4787C62A);
		c=FF(c,d,a,b,x[k+6], S13,0xA8304613);
		b=FF(b,c,d,a,x[k+7], S14,0xFD469501);
		a=FF(a,b,c,d,x[k+8], S11,0x698098D8);
		d=FF(d,a,b,c,x[k+9], S12,0x8B44F7AF);
		c=FF(c,d,a,b,x[k+10],S13,0xFFFF5BB1);
		b=FF(b,c,d,a,x[k+11],S14,0x895CD7BE);
		a=FF(a,b,c,d,x[k+12],S11,0x6B901122);
		d=FF(d,a,b,c,x[k+13],S12,0xFD987193);
		c=FF(c,d,a,b,x[k+14],S13,0xA679438E);
		b=FF(b,c,d,a,x[k+15],S14,0x49B40821);
		a=GG(a,b,c,d,x[k+1], S21,0xF61E2562);
		d=GG(d,a,b,c,x[k+6], S22,0xC040B340);
		c=GG(c,d,a,b,x[k+11],S23,0x265E5A51);
		b=GG(b,c,d,a,x[k+0], S24,0xE9B6C7AA);
		a=GG(a,b,c,d,x[k+5], S21,0xD62F105D);
		d=GG(d,a,b,c,x[k+10],S22,0x2441453);
		c=GG(c,d,a,b,x[k+15],S23,0xD8A1E681);
		b=GG(b,c,d,a,x[k+4], S24,0xE7D3FBC8);
		a=GG(a,b,c,d,x[k+9], S21,0x21E1CDE6);
		d=GG(d,a,b,c,x[k+14],S22,0xC33707D6);
		c=GG(c,d,a,b,x[k+3], S23,0xF4D50D87);
		b=GG(b,c,d,a,x[k+8], S24,0x455A14ED);
		a=GG(a,b,c,d,x[k+13],S21,0xA9E3E905);
		d=GG(d,a,b,c,x[k+2], S22,0xFCEFA3F8);
		c=GG(c,d,a,b,x[k+7], S23,0x676F02D9);
		b=GG(b,c,d,a,x[k+12],S24,0x8D2A4C8A);
		a=HH(a,b,c,d,x[k+5], S31,0xFFFA3942);
		d=HH(d,a,b,c,x[k+8], S32,0x8771F681);
		c=HH(c,d,a,b,x[k+11],S33,0x6D9D6122);
		b=HH(b,c,d,a,x[k+14],S34,0xFDE5380C);
		a=HH(a,b,c,d,x[k+1], S31,0xA4BEEA44);
		d=HH(d,a,b,c,x[k+4], S32,0x4BDECFA9);
		c=HH(c,d,a,b,x[k+7], S33,0xF6BB4B60);
		b=HH(b,c,d,a,x[k+10],S34,0xBEBFBC70);
		a=HH(a,b,c,d,x[k+13],S31,0x289B7EC6);
		d=HH(d,a,b,c,x[k+0], S32,0xEAA127FA);
		c=HH(c,d,a,b,x[k+3], S33,0xD4EF3085);
		b=HH(b,c,d,a,x[k+6], S34,0x4881D05);
		a=HH(a,b,c,d,x[k+9], S31,0xD9D4D039);
		d=HH(d,a,b,c,x[k+12],S32,0xE6DB99E5);
		c=HH(c,d,a,b,x[k+15],S33,0x1FA27CF8);
		b=HH(b,c,d,a,x[k+2], S34,0xC4AC5665);
		a=II(a,b,c,d,x[k+0], S41,0xF4292244);
		d=II(d,a,b,c,x[k+7], S42,0x432AFF97);
		c=II(c,d,a,b,x[k+14],S43,0xAB9423A7);
		b=II(b,c,d,a,x[k+5], S44,0xFC93A039);
		a=II(a,b,c,d,x[k+12],S41,0x655B59C3);
		d=II(d,a,b,c,x[k+3], S42,0x8F0CCC92);
		c=II(c,d,a,b,x[k+10],S43,0xFFEFF47D);
		b=II(b,c,d,a,x[k+1], S44,0x85845DD1);
		a=II(a,b,c,d,x[k+8], S41,0x6FA87E4F);
		d=II(d,a,b,c,x[k+15],S42,0xFE2CE6E0);
		c=II(c,d,a,b,x[k+6], S43,0xA3014314);
		b=II(b,c,d,a,x[k+13],S44,0x4E0811A1);
		a=II(a,b,c,d,x[k+4], S41,0xF7537E82);
		d=II(d,a,b,c,x[k+11],S42,0xBD3AF235);
		c=II(c,d,a,b,x[k+2], S43,0x2AD7D2BB);
		b=II(b,c,d,a,x[k+9], S44,0xEB86D391);
		a=AddUnsigned(a,AA);
		b=AddUnsigned(b,BB);
		c=AddUnsigned(c,CC);
		d=AddUnsigned(d,DD);
	}
 
	var temp = WordToHex(a)+WordToHex(b)+WordToHex(c)+WordToHex(d);
 
	return temp.toLowerCase();
}

function SetOpacity(element, opacity)
{
	if (element.style.opacity)
	{
		element.style.opacity = opacity;
	}
	else if (element.filters)
	{
		element.filters.alpha.opacity = 100 * opacity;
	}
}

/**
 * Updates state of game database.
 * 
 * @return void
 */
function UpdateGameState()
{
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState == 4)
		{
			document.location.reload();
		}
	}

	var url = "updater.php?rand=" + Math.random();
	
	xmlhttp.open("GET", url, true);
	xmlhttp.send(null);
}

/**
 * Current screen width.
 */
var screenWidth = 1024;

/**
 * Current screen height.
 */
var screenHeight = 768;

/**
 * Gets screen dimensions as 2-length array [x, y].
 * 
 * @return screen dimensions as 2-length array [x, y]
 */
function GetScreenSize()
{
	if (parseInt(navigator.appVersion)>3) 
	{
		screenWidth = screen.width;
		screenHeight = screen.height;
	}
	else if (navigator.appName == "Netscape" && parseInt(navigator.appVersion)==3 && navigator.javaEnabled()) 
	{
		var jToolkit = java.awt.Toolkit.getDefaultToolkit();
		var jScreenSize = jToolkit.getScreenSize();
		screenWidth = jScreenSize.width;
		screenHeight = jScreenSize.height;
	}
	
	var size = new Array();
	size[0] = screenWidth;
	size[1] = screenHeight;
	
	return size;
}

function TranslateTerm(termName, target, prefix, suffix)
{
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{
			if (!prefix) 
			{
				prefix = "";
			}
			
			if (!suffix) 
			{
				suffix = "";
			}
			
			target.innerHTML = prefix + xmlhttp.responseText + suffix;
		}
	}

	var url = "responder.php?action=Translate" + 
		"&termName=" + termName + 
		"&rand=" + Math.random();
	
	xmlhttp.open("GET", url, true);
	xmlhttp.send(null);
}

function IsChildParent(child, parent)
{
	while (child != null)
	{
		if (child == parent)
		{
			return true;
		}
		
		child = child.parentNode;
	}
	
	return false;
}

function IsPositiveIntegerString(number)
{
	var reg = /^\d+$/;
	
	if(reg.test(number) == false) 
	{
		return false;
	}
	
	return true;
}

function SetElementBorderWidth(elem, borderWidth)
{
	var left = parseFloat(elem.style.left);
	var top = parseFloat(elem.style.top);
	
	var oldBorderWidth = parseFloat(elem.style.borderWidth);
	var delta = borderWidth - oldBorderWidth;
	
	elem.style.left = (left - delta / 2) + "px";
	elem.style.top = (top - delta / 2) + "px";
	elem.style.borderWidth = borderWidth + "px";
}

function DrawLine(x0, y0, x1, y1, id, color, width, name)
	{
		if (!color)
		{
			color = "White";	
		}
		
		if (!width)
		{
			width = 1;
		}
		
		//alert(sprintf("x0=%f; y0=%f; x1=%f; y1=%f", x0, y0, x1, y1));
		var dx = x1 - x0, dy = y1 - y0;
		//alert(sprintf("dx=%f; dy=%f", dx, dy));
		var length = Math.sqrt(dx * dx + dy * dy);
		var angle = Math.atan2(y1 - y0, x1 - x0);
		angle *= 180 / Math.PI;
		
		var style = "position: absolute;";
		style += "left: " + x0 + "px;";
		style += "top: " + (y0 - width / 2)  + "px;";
		style += "width: " + length + "px;";
		style += "height: " + width + "px;";
		style += "background-color: " + color + ";";
		
		style += "rotation-point: 0% 50%;"; // CSS 3
		style += "rotation: " + angle + "deg;";
		style += "-webkit-transform-origin: 0% 50%;"; // pro chrome
		style += "-webkit-transform: rotate(" + angle + "deg);";
		style += "-moz-transform-origin: 0% 50%;";  // pro firefox
		style += "-moz-transform: rotate(" + angle + "deg);";
		style += "-o-transform-origin: 0% 50%;";	// pro operu
		style += "-o-transform: rotate(" + angle + "deg);";  
		
		var elemHTML = "<div style=\"" + style + "\"";
		
		if (name != null)
		{
			elemHTML += " name=\"" + name + "\"";
		}
		
		if (id != null)
		{
			elemHTML += " id=\"" + id + "\"";
		}
		
		elemHTML += "></div>\n";
		
		var boxDiv = document.createElement("div");
		boxDiv.innerHTML = elemHTML;
		
		return boxDiv.firstChild;
	}	

// This code is in the public domain. Feel free to link back to http://jan.moesen.nu/
// from http://jan.moesen.nu/code/javascript/sprintf-and-printf-in-javascript/
function sprintf()
{
    if (!arguments || arguments.length < 1 || !RegExp) 
    {
        return;
    }
    var str = arguments[0];
    var re = /([^%]*)%('.|0|\x20)?(-)?(\d+)?(\.\d+)?(%|b|c|d|u|f|o|s|x|X)(.*)/;
    var a = b = [], numSubstitutions = 0, numMatches = 0;
    while (a = re.exec(str)) 
    {
        var leftpart = a[1], pPad = a[2], pJustify = a[3], pMinLength = a[4];
        var pPrecision = a[5], pType = a[6], rightPart = a[7];
        
        //alert(a + '\n' + [a[0], leftpart, pPad, pJustify, pMinLength, pPrecision);
        
        numMatches++;
        if (pType == '%') 
        {
            subst = '%';
        }
        else 
        {
            numSubstitutions++;
            if (numSubstitutions >= arguments.length) 
            {
                alert('Error! Not enough function arguments (' + (arguments.length - 1) + ', excluding the string)\nfor the number of substitution parameters in string (' + numSubstitutions + ' so far).');
            }
            var param = arguments[numSubstitutions];
            var pad = '';
            if (pPad && pPad.substr(0, 1) == "'") 
                pad = leftpart.substr(1, 1);
            else 
                if (pPad) 
                    pad = pPad;
            var justifyRight = true;
            if (pJustify && pJustify === "-") 
                justifyRight = false;
            var minLength = -1;
            if (pMinLength) 
                minLength = parseInt(pMinLength);
            var precision = -1;
            if (pPrecision && pType == 'f') 
                precision = parseInt(pPrecision.substring(1));
            var subst = param;
            if (pType == 'b') 
                subst = parseInt(param).toString(2);
            else 
                if (pType == 'c') 
                    subst = String.fromCharCode(parseInt(param));
                else 
                    if (pType == 'd') 
                        subst = parseInt(param) ? parseInt(param) : 0;
                    else 
                        if (pType == 'u') 
                            subst = Math.abs(param);
                        else 
                            if (pType == 'f') 
                                subst = (precision > -1) ? Math.round(parseFloat(param) * Math.pow(10, precision)) / Math.pow(10, precision) : parseFloat(param);
                            else 
                                if (pType == 'o') 
                                    subst = parseInt(param).toString(8);
                                else 
                                    if (pType == 's') 
                                        subst = param;
                                    else 
                                        if (pType == 'x') 
                                            subst = ('' + parseInt(param).toString(16)).toLowerCase();
                                        else 
                                            if (pType == 'X') 
                                                subst = ('' + parseInt(param).toString(16)).toUpperCase();
        }
        str = leftpart + subst + rightPart;
    }
    return str;
}

// ////////////////////////////////////////////////////////////////////////////////////////
// / index.php
// ////////////////////////////////////////////////////////////////////////////////////////

/**
 * Loads index page content using AJAX.
 * 
 * @return void
 */
function LoadContent()
{
	var xmlhttp = GetXMLHTTP();
	xmlhttp.onreadystatechange = function()
	{
		if(xmlhttp.readyState==4)
		{
			ViewContent(xmlhttp.responseText);
		}
	}

	var screenSize = GetScreenSize();
	// alert(screenSize.toString());
	var url = "content.php?getContent" + 
		"&screenWidth=" + screenSize[0] +
		"&screenHeight=" + screenSize[1] +
		"&rand=" + Math.random();
	
	xmlhttp.open("GET", url, true);
	xmlhttp.send(null);
}

/**
 * Displays index.php content recieved from AJAX.
 * 
 * @param content
 *            html code with content
 * @return void
 */
function ViewContent(content)
{
	var contentDiv = document.getElementById("pageContent");
	contentDiv.innerHTML = content;

	while (true)
	{
		var startMark = "<script type=\"text/javascript\">";
		var start = content.search(startMark);
		if (start < 0)
		{
			break;
		}
		var end = content.search("<"+"/script"+">");
		if (end < 0)
		{
			break;
		}

		start += startMark.length;

		var code = content.substr(start, end - start);
		content = content.substr(end, content.length - end);

		startMark = '<' + '!--';
		start = code.search(startMark);
		if (start < 0)
		{
			break;
		}
		
		end = code.search("//-" + "->");
		if (end < 0)
		{
			break;
		}

		start += startMark.length;

		code = code.substr(start, end - start);
		eval(code);
	}
	
	GameInit();
}

// ////////////////////////////////////////////////////////////////////////////////////////
// / index2.php
// ////////////////////////////////////////////////////////////////////////////////////////

/**
 * Reports screen size to server using POST method of form.
 */
function ReportScreenSize()
{
	var form = document.getElementById("screenReporter");
	var screenWidthInput = document.getElementById("screenWidth");
	var screenHeightInput = document.getElementById("screenHeight");
	
	var screenSize = GetScreenSize();
	screenWidthInput.value = screenSize[0];
	screenHeightInput.value = screenSize[1];
	
	form.submit();
}