<?php

require_once('View/Control.inc');
require_once('Control/Dictionary.inc');
require_once('Control/Globals.inc');

class DisplayFilterPanel extends Control
{
	private $gamePlan;
		
	private $htmlId;
	
	public function GetHtmlId()
	{
		return $this->htmlId;
	}
	
	public function SetHtmlId($newId)
	{
		if ($newId == NULL)
		{
			throw new Exception("ID must not be NULL.");
		}
		$this->htmlId = $newId;
	}
	
	const CLASS_NAME = "DisplayFilterPanel";
		
	public function __construct()
	{
		$this->htmlId = self::CLASS_NAME;
		$this->SetBackgroundColor("DeepSkyBlue");
	}	
		
	public function Render()
	{	
		echo '<div id="'.$this->GetHtmlId().'" class="'.self::CLASS_NAME.'" style="'.$this->GenerateStyleString().'"';
		echo 'onclick="'.self::CLASS_NAME.'_OnClick(event)">'."\n";
		$this->RenderContent();
		echo "</div>\n";
	}
	
	public function RenderContent()
	{
		$dictionary = Dictionary::GetInstance();
		
		//echo "<div style=\"margin: 0 auto; width=\"100px\"\">";
		
		$formId = $this->GetHtmlId().'_Form';
		echo '<form id="'.$formId.'" method="post" action="" ' . ">\n";
		
		echo '<input type="checkbox" id="'.$formId.'_ships" name="ships" checked="checked" ';
		echo "onchange=\"DisplayFilterPanel_Changed('ships', this.checked)\" />";
		echo '<label for="'.$formId.'_ships">'.$dictionary->Translate("DISPLAY_SHIPS")."</label>";
		
		echo "&nbsp;&nbsp;&nbsp;&nbsp;";
		
		echo '<input type="checkbox" id="'.$formId.'_buildings" name="buildings" checked="checked" ';
		echo "onchange=\"DisplayFilterPanel_Changed('buildings', this.checked)\" />";
		echo '<label for="'.$formId.'_buildings">'.$dictionary->Translate("DISPLAY_BUILDINGS")."</label>";
		
		echo "&nbsp;&nbsp;&nbsp;&nbsp;";
		
		echo '<input type="checkbox" id="'.$formId.'_trajectories" name="trajectories" checked="checked" ';
		echo "onchange=\"DisplayFilterPanel_Changed('trajectories', this.checked)\" />";
		echo '<label for="'.$formId.'_trajectories">'.$dictionary->Translate("DISPLAY_TRAJECTORIES")."</label>";
		
		echo "</form>\n";
		
		//echo "</div>\n";			
		
	}
}
?>