<?php

require_once("Control/Utils.inc");

class Graphics
{
	static function DrawLine(array $a, array $b, $color = "black", $width = 1.0, $name = NULL, $id = NULL)
	{
		$length = Utils::GetVector2Length(Utils::SubtractVertices2($a, $b));
		$angle = atan2($b[1] - $a[1], $b[0] - $a[0]);
		$angle *= 180 / M_PI;
		
		$style = "position: absolute;";
		$style .= "left: ".$a[0]."px;";
		$style .= "top: ".$a[1]."px;";
		$style .= "width: ".$length."px;";
		$style .= "height: ".$width."px;";
		$style .= "background-color: ".$color.";";
		
		$style .= "rotation-point: 0% 0%;"; // CSS 3
		$style .= "rotation: ".$angle."deg;";
		$style .= "-webkit-transform-origin: 0% 0%;"; // pro chrome
		$style .= "-webkit-transform: rotate(".$angle."deg);";
		$style .= "-moz-transform-origin: 0% 0%;";  // pro firefox
		$style .= "-moz-transform: rotate(".$angle."deg);";
		$style .= "-o-transform-origin: 0% 0%;";	// pro operu
		$style .= "-o-transform: rotate(".$angle."deg);";  
		
		echo "<div style=\"".$style."\"";
		
		if ($name != NULL)
		{
			echo " name=\"" . $name . "\"";
		}
		
		if ($id != NULL)
		{
			echo " id=\"" . $id . "\"";
		}
		
		echo "></div>\n";
	}
	
	static function PrintBtn($title, $x, $y, $width, $height, $onclick, $backgroundImageURL = "")
	{
		$backgroundImageURL = trim($backgroundImageURL);
		
		$divStyle = sprintf("position: absolute; left: %fpx; top: %fpx; width: %fpx; height: %fpx;", $x, $y, $width, $height);
		$divStyle .= "cursor: pointer;";
		
		if (strlen($backgroundImageURL) > 0)
		{
			$divStyle .= "background-image:url('".$backgroundImageURL."');";
		}
		
		echo "<div ";
		echo "style=\"".$divStyle."\" ";
		echo "title=\"".$title."\" ";
		echo "onclick=\"".$onclick."\" ";
		echo ">";
		
		echo "</div>";
	}
	
	static function PrintTextBtn($lbl, $x, $y, $style = "", $class = "", $onclick = "", $title = "")
	{
		$onclick = trim($onclick);
		$class = trim($class);
		$style = trim($style);
		$style .= "margin: 0px 0px;";
		
		$divStyle = sprintf("position: absolute; left: %fpx; top: %fpx;", $x, $y);
		$divStyle .= "padding: 0px 0px;";
		
		echo "<div ";
		echo "style=\"".$divStyle."\" ";
		echo "title=\"".$title."\" ";
		echo ">";
		
		echo "<span ";
		
		if (strlen($style) > 0)
		{
			echo "style=\"".$style."\" ";
		}
		
		if (strlen($class) > 0)
		{
			echo "class=\"".$class."\" ";
		}
		
		if (strlen($onclick) > 0)
		{
			echo "onclick=\"".$onclick."\" ";
		}
		
		echo ">\n";
		
		echo $lbl;
		echo "</span>\n";
		
		echo "</div>";
	}	
}

?>