<?php

require_once('View/Control.inc');
require_once('View/Graphics.inc');
require_once('Control/Globals.inc');

class LanguageSelector extends Control
{
	private $htmlId;
	
	private $languageCode;
	
	public function __construct($defaultLanguageCode = -1)
	{
		$this->htmlId = "LanguageSelector_" . rand();
		
		if ($defaultLanguageCode < 0)
		{
			$defaultLanguageCode = Globals::GetLanguage();
		}
		
		$this->languageCode = $defaultLanguageCode;
		$this->SetBackgroundColor("Transparent");
	}
	
	public function GetHtmlId()
	{
		return $this->htmlId;
	}
	
	public function Render()
	{
		$style = $this->GenerateStyleString();
		echo '<div id="'.$this->GetHtmlId().'" class="LanguageSelector" style="'.$style.'">'."\n";
		
		/*$flagHeight = $this->GetHeight() * 0.8;
		$flagWidth = $flagHeight * 3.0 / 2.0;
		$style = 'margin: ' . ($this->GetHeight() * 0.1) . 'px; cursor: pointer; float: right;';
		
		echo '<img src="Images/flag_uk.png" alt="English (UK)" '.
			'width="'.$flagWidth.'px" height="'.$flagHeight.'px" style="'.$style.'" '.
			'onclick="SetLanguage(1)"/>'."\n";		
		echo '<img src="Images/flag_cz.png" alt="ÄŚeĹˇtina" '.
			'width="'.$flagWidth.'px" height="'.$flagHeight.'px" style="'.$style.'" '.
			'onclick="SetLanguage(0)"/>'."\n";*/
		
		Graphics::PrintBtn("Čeština", 0, 0, 18, 17, "SetLanguage(0)", "Images/interface/language_selector/btn_cz.png");	
		Graphics::PrintBtn("English (UK)", 18, 0, 19, 17, "SetLanguage(1)", "Images/interface/language_selector/btn_en.png");         
		
		echo "</div>\n";	
	}
}

?>