<?php

require_once('View/Control.inc');
require_once('View/GamePlan.inc');
require_once('Control/Dictionary.inc');
require_once('Control/Utils.inc');

class LeftMenuPanel extends Control
{
	const CLASS_NAME = "LeftMenuPanel";
	
	const BTN_WIDTH = 133;
	const BTN_HEIGHT_A = 20;
	const BTN_HEIGHT_B = 21;
	
	const BTN_OFFSET_X = 65;
	const BTN_FIRST_OFFSET_Y = 262;
	
	const BTN_IMAGE_PREFIX = "Images/interface/left_panel/";
	const BTN_IMAGE_POSTFIX = ".png";
	
	private $htmlId;
	
	public function __construct()
	{
		$this->htmlId = self::CLASS_NAME;
	}
	
	public function GetHtmlId()
	{
		return $this->htmlId;
	}
	
	public function Render()
	{
		$style = $this->GenerateStyleString();
		$style .= "background-image:url('Images/interface/left_panel.png');";
		echo '<div id="'.$this->GetHtmlId().'" class="'.self::CLASS_NAME.'" style="'.$style.'"';
		echo '>'."\n";
		
		$this->RenderContent();
		
		echo "</div>\n";	
	}
	
	public function RenderContent()
	{
		$dictionary = Dictionary::GetInstance();
		
		echo "<div style=\"position: absolute; left: ".self::BTN_OFFSET_X."px; top: ".self::BTN_FIRST_OFFSET_Y."px;\">";
		
		$this->RenderBtn($dictionary->Translate("BUY_SHIP_PANEL"), self::BTN_HEIGHT_B, "btn_buy_ship", "ShipShopPanel_Show()");
		$this->RenderBtn($dictionary->Translate("BUY_LICENCE_PANEL"), self::BTN_HEIGHT_B, "btn_buy_licence", "MenuPanel_BuyLicence(false)");
		$this->RenderBtn($dictionary->Translate("ASSIGN_GUARDS"), self::BTN_HEIGHT_A, "btn_ship_management", "GuardAssignmentPanel_Show()");
		$this->RenderBtn($dictionary->Translate("SHOW_HIGHSCORE"), self::BTN_HEIGHT_B, "btn_player_score", "HighScorePanel_Show()");
		$this->RenderBtn($dictionary->Translate("SHOW_DIPLOMACY"), self::BTN_HEIGHT_B, "btn_alliance", "EmbassyPanel_Show()");
		$this->RenderBtn($dictionary->Translate("SHOW_GALAXY_MAP"), self::BTN_HEIGHT_B, "btn_galaxy_map", "GalaxyMap_Show()");
		$this->RenderBtn("", self::BTN_HEIGHT_A, "btn_help", "");
		
		echo "</div>\n";
	}
	
	public function RenderBtn($title, $height, $imageName, $onClick)
	{
		$imageNameFull = self::BTN_IMAGE_PREFIX . $imageName . self::BTN_IMAGE_POSTFIX;
		$imageNameFullActive = self::BTN_IMAGE_PREFIX . $imageName . "_active" . self::BTN_IMAGE_POSTFIX;
		$style = "width: ".self::BTN_WIDTH."px; height: ".$height."px; ";
		$style .= "background-image:url('".$imageNameFull."');";
		$style .= "cursor: pointer;";
		
		echo "<div ";
		echo "style=\"".$style."\" ";
		echo "class=\"".self::CLASS_NAME."_btn\" ";
		echo "onmouseover=\"this.style.backgroundImage='url(".$imageNameFullActive.")'\" ";
		echo "onmouseout=\"this.style.backgroundImage='url(".$imageNameFull.")'\" ";
		echo "onclick=\"".$onClick."\" ";
		echo "title=\"".$title."\" ";
		echo "></div>\n";
	}
}

?>