<?php

/**
 * Object of WWW page.
 */
class Page
{
	/**
	 * Page title.
	 */
	private $title;
	
	private $onLoad;
	
	public function SetOnLoad($script)
	{
		$this->onLoad = $script;
	}

	/**
	 * Creates new WWW page with specified title.
	 * @param title page title
	 */
	public function __construct($title)
	{
		if ($title == NULL)
		{
			throw new Exception("Title parameter missing.");
		}
			
		$this->title = $title;
		$this->onLoad = NULL;
	}

	/**
	 * Prints page header for XHTML 1.0 Strict, UTF8 and czech language.
	 * @param inset added info to header
	 */
	public function PrintHeader($inset = "")
	{
		echo "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">\n";
		echo "<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"cz\" lang=\"cs\">\n";
		echo "<head>\n";
		echo "<title>".$this->title."</title>\n";
		echo "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" />\n";
		echo "<link rel=\"stylesheet\" type=\"text/css\" href=\"View/controls.css\" />\n";
		echo '<script type="text/javascript" src="Scripts/utils.js"></script>'."\n";
		echo '<script type="text/javascript" src="Scripts/gameLogic.js"></script>'."\n";
		echo '<script type="text/javascript" src="Scripts/userManagement.js"></script>'."\n";
		echo '<script type="text/javascript" src="Scripts/messaging.js"></script>'."\n";
		echo $inset;
		echo "</head>\n";
		echo "<body";
		
		if ($this->onLoad != NULL)
		{
			echo " onload=\"".$this->onLoad."\"";
		}
		
		echo ">\n";
	}

	/**
	 * Prints page footer.
	 */
	public function PrintFooter()
	{
		echo "</body>\n";
		echo "</html>\n";
	}

}