<?php

require_once("View/GameScreen.inc");
require_once("View/IntroScreen.inc");

require_once("Control/DBManager.inc");
require_once("Control/Dictionary.inc");
require_once("Control/Globals.inc");
require_once("View/DesignConstants.inc");

/**
 * This is content page of game loaded using AJAX in index.php or included in index2.php
 */

if (!$_SESSION)
{
	session_start();	
}

/* inputs */

if (!array_key_exists("getContent", $_REQUEST))
{
	echo "Invalid access.\n";
	exit(1);
}

if (array_key_exists("screenWidth", $_REQUEST))
{
	$screenWidth = $_REQUEST["screenWidth"];
}
else
{
	$screenWidth = DesignConstants::DEFAULT_SCREEN_WIDTH;
}

if (array_key_exists("screenHeight", $_REQUEST))
{
	$screenHeight = $_REQUEST["screenHeight"];
}
else
{
	$screenHeight = DesignConstants::DEFAULT_SCREEN_WIDTH;
}


$gamePlanSize = DesignConstants::GetGamePlanSize($screenWidth, $screenHeight);
Globals::SetGamePlanSize($gamePlanSize);

/* content */

$player = Globals::GetActivePlayer();

if ($player != NULL || array_key_exists("guest", $_REQUEST))
{
	$gameScreen = new GameScreen($screenWidth, $screenHeight);
	$gameScreen->Render();
}
else
{
	$intro = new IntroScreen();
	$intro->Render();
}

/* finalize */

$dbManager = DBManager::GetInstance();
$dbManager->Dispose();

?>
