<?php
require_once("View/Page.inc");
require_once("Model/SolarSystem.inc");
require_once("Control/DBManager.inc");

require_once("Model/Delivery.inc");
require_once("Model/Planet.inc");
require_once("Model/GoodType.inc");
require_once("Model/Player.inc");
require_once("Model/Ship.inc");

require_once("Control/ShipActionController.inc");

/**
 * Temporary file for presentation of basic functions.
 */


$page = new Page("KIV Webgame prealpha internal");

$css = "<style type=\"text/css\">
td 
{
	border: 1px solid black;
	width: 100px;
	background-color: rgb(209, 240, 252);
}

thead td
{
	background-color: rgb(173, 219, 245);
}

body
{
	background-color: rgb(227, 245, 253);
}

table 
{
	border-collapse: collapse;
}
</style>\n";

$page->PrintHeader($css);


$solarSystem = SolarSystem::LoadFromDB();

echo "<a href=\"index.php\" style=\"color: black; font-weight: bold; text-decoration: none\">&lt;&lt; Zpět na hru</a>\n";
echo "<h1 style=\"color: rgb(17, 51, 113); font-family: Calibri, Arial\">Výpis stavu aplikace</h1>\n";

echo "<p>\n";
$date = getdate();
echo "<b>Platnost: ".$date['mday'].". ".$date['mon'].". ".$date['year'];
printf(" %02d:%02d:%02d</b><br/>\n", $date['hours'], $date['minutes'], $date['seconds']);

echo "<span onclick=\"UpdateGameState()\" style=\"color: black; font-weight: bold;\">&gt;&gt; ".
"<span style=\"text-decoration: underline;\">Aktualizovat stav hry</span> &lt;&lt;</span>";


echo "</p>\n";

echo "<h3>Stav NPC hráče</h3>\n";

$npc = Player::LoadPCPlayerFromDB();
$ships = (array)$npc->GetShipsForced();

echo "<p>";
echo "<b>Peníze: </b>".$npc->GetMoney()."<br/>";
echo "</p>\n";

echo "<table>\n";
	echo "<thead style=\"font-weight: bold;\">\n";
	echo "<tr><td style=\"text-align: center; width: 25px;\"><b>#</b></td><td>Jméno lodě</td>".
		 "<td>Pozice lodě</td><td>Stav lodě</td><td style=\"width: 250px;\">Čas do odblokování (real/in-game)</td></tr>\n";
	echo "</thead>\n";
	echo "<tbody>\n";

$i = 1;
foreach ($ships as $ship)
{
	echo "<tr>\n";
	echo "<td style=\"text-align: center; width: 25px;\">".$i."</td>\n";

	$shipController = new ShipActionController($npc, $ship);
	$shipController->UpdateState();

	printf("<td>%s</td>\n", $ship->GetName());
	$dockedPlanet = $shipController->GetDockedPlanet();
	printf("<td>%s</td>\n", $dockedPlanet == NULL ? "" : $dockedPlanet->GetName());

	echo "<td>";
	if ($shipController->IsBlocked())
	{
		echo "blokována";
	}
	else if ($shipController->IsWaiting())
	{
		echo "připravená";
	}
	else if ($shipController->IsFlying())
	{
		echo "letí";
	}
	else if ($shipController->IsGuarding())
	{
		echo "brani " . Ship::LoadFromDB($shipController->GetGuardedShipId())->GetName();
	}
	echo "</td>\n";
	
	echo "<td>";
	if ($shipController->IsBlocked())
	{
		$remTime = $shipController->GetBlockEndTime() - time();
		echo $remTime . " s / " . floor(GameTimer::RealTimeToEarthDays($remTime)) . " dní";
	}
	else 
	{
		echo "-";		
	}
	echo "</td>\n";

	echo "</tr>\n";
	
}

echo "</tbody>\n";
echo "</table>\n";
	
//
//
//

echo "<hr/>\n";
echo "<hr/>\n";

echo "<h3>Planety</h3>\n";


$planets = (array)$solarSystem->GetPlanets();
foreach ($planets as $planet)
{
	echo "<p>";
	echo "<b>Název: <i>".$planet->GetName()."</i></b><br/>";
	echo "<b>Pozice: </b>&lt;".$planet->GetWorldX()."; ".$planet->GetWorldY()."&gt;<br/>";
	echo "<b>Délka roku (dní):</b> ".$planet->GetYearLengthInDays()."<br/>";
	echo "<b>Číslo dne v roce (od 1):</b> ".($planet->GetCurrentPlanetDay() + 1)."<br/>";
	echo "</p>\n";

	echo "<h4>Zboží</h4>\n";

	echo "<table>\n";
	echo "<thead style=\"font-weight: bold;\">\n";
	echo "<tr><td style=\"text-align: center; width: 25px;\"><b>#</b></td><td>Typ</td><td>Množství (tun)</td><td>Cíl</td><td>Odměna</td></tr>\n";
	echo "</thead>\n";
	echo "<tbody>\n";

	$i = 1;
	$deliveries = (array)$planet->GetDeliveriesForced();
	foreach ($deliveries as $delivery)
	{
		echo "<tr>\n";
		echo "<td style=\"text-align: center; width: 25px;\">".$i."</td>\n";
		echo "<td>".$delivery->GetGoodType()->GetName()."</td>\n";
		echo "<td style=\"text-align: right;\">".$delivery->GetAmount()."</td>\n";

		$target = $planets[$delivery->GetTargetPlanetId()];

		echo "<td>".$target->GetName()."</td>\n";
		echo "<td style=\"text-align: right;\">".$delivery->GetPrice()."</td>\n";

		echo "</tr>\n";

		$i++;
	}


	echo "</tbody>\n";
	echo "</table>\n";

	echo "<hr/>\n";
}


$page->PrintFooter();


$dbManager = DBManager::GetInstance();
$dbManager->Dispose();

?>