<?php

require_once("Control/DBManager.inc");
require_once("Control/Responder.inc");
require_once("View/DesignConstants.inc");

/**
 * This page responds on client scritps.
 */

session_start();

if (array_key_exists("screenWidth", $_REQUEST))
{
	$screenWidth = $_REQUEST["screenWidth"];
}
else
{
	$screenWidth = DesignConstants::DEFAULT_SCREEN_WIDTH;
}

if (array_key_exists("screenHeight", $_REQUEST))
{
	$screenHeight = $_REQUEST["screenHeight"];
}
else
{
	$screenHeight = DesignConstants::DEFAULT_SCREEN_WIDTH;
}

$gamePlanSize = DesignConstants::GetGamePlanSize($screenWidth, $screenHeight);


if (!strcmp($_REQUEST["action"], "GetPlanetPositions"))
{
	Responder::GetPlanetPositions($gamePlanSize);
}
else if (!strcmp($_REQUEST["action"], "GetShipPositions"))
{
	Responder::GetShipPositions($gamePlanSize);
}
else if (!strcmp($_REQUEST["action"], "login"))
{
	if (array_key_exists("login", $_REQUEST))
	{
		$login = $_REQUEST["login"];
	}

	if (array_key_exists("password", $_REQUEST))
	{
		$password = $_REQUEST["password"];
	}

	if (array_key_exists("width", $_REQUEST))
	{
		$width = $_REQUEST["width"];
	}

	if (array_key_exists("panelId", $_REQUEST))
	{
		$panelId = $_REQUEST["panelId"];
	}

	Responder::Login($login, $password, $width, $panelId);
}
else if (!strcmp($_REQUEST["action"], "SetLanguage"))
{
	if (array_key_exists("languageCode", $_REQUEST))
	{
		$languageCode = $_REQUEST["languageCode"];
		Responder::SetLanguage($languageCode);
	}
}
else if (!strcmp($_REQUEST["action"], "GoToSystem"))
{
	if (array_key_exists("systemId", $_REQUEST))
	{
		$systemId = $_REQUEST["systemId"];
		Responder::GoToSystem($systemId);
	}
}
else if (!strcmp($_REQUEST["action"], "Translate"))
{
	if (array_key_exists("termName", $_REQUEST))
	{
		$termName = $_REQUEST["termName"];
		Responder::TranslateTerm($termName);
	}
}
else if (!strcmp($_REQUEST["action"], "GetMenu"))
{
	if (array_key_exists("selectionType", $_REQUEST))
	{
		$selectionType = $_REQUEST["selectionType"];
	}

	if (array_key_exists("itemId", $_REQUEST))
	{
		$itemId = $_REQUEST["itemId"];
	}

	Responder::GetMenu($itemId, $selectionType);
}
else if (!strcmp($_REQUEST["action"], "GetDeliveryPanel"))
{
	if (array_key_exists("planetId", $_REQUEST))
	{
		$planetId = $_REQUEST["planetId"];
	}
	
	if (array_key_exists("sortKey", $_REQUEST))
	{
		$sortKey = $_REQUEST["sortKey"];
	}

	if (array_key_exists("sortOrder", $_REQUEST))
	{
		$sortOrder = $_REQUEST["sortOrder"];
	}

	Responder::GetDeliveryPanel($planetId, $sortKey, $sortOrder);
}
else if (!strcmp($_REQUEST["action"], "GetPlanetInfoPanel"))
{
	if (array_key_exists("planetId", $_REQUEST))
	{
		$planetId = $_REQUEST["planetId"];
	}

	Responder::GetPlanetInfoPanel($planetId);
}
else if (!strcmp($_REQUEST["action"], "GetPlanetGraphic"))
{
	if (array_key_exists("planetId", $_REQUEST))
	{
		$planetId = $_REQUEST["planetId"];
	}
	
	if (array_key_exists("planetGraphicId", $_REQUEST))
	{
		$planetGraphicId = $_REQUEST["planetGraphicId"];
	}

	Responder::GetPlanetGraphic($planetId, $planetGraphicId);
}
else if (!strcmp($_REQUEST["action"], "GetShipGraphic"))
{
	if (array_key_exists("shipId", $_REQUEST))
	{
		$shipId = $_REQUEST["shipId"];
	}
	
	Responder::GetShipGraphic($shipId);
}
else if (!strcmp($_REQUEST["action"], "GetShipSelectionPanel"))
{
	if (array_key_exists("deliveryId", $_REQUEST))
	{
		$deliveryId = $_REQUEST["deliveryId"];
	}

	Responder::GetShipSelectionPanel($deliveryId);
}
else if (!strcmp($_REQUEST["action"], "GetPlanetHomePlayersPanel"))
{
	if (array_key_exists("planetId", $_REQUEST))
	{
		$planetId = $_REQUEST["planetId"];
	}

	Responder::GetPlanetHomePlayersPanel($planetId);
}
else if (!strcmp($_REQUEST["action"], "GetShipShopPanel"))
{
	Responder::GetShipShopPanel();
}
else if (!strcmp($_REQUEST["action"], "GetGuardAssignmentPanel"))
{
	Responder::GetGuardAssignmentPanel();
}
else if (!strcmp($_REQUEST["action"], "GetHighScorePanel"))
{
	if (array_key_exists("sortKey", $_REQUEST))
	{
		$sortKey = $_REQUEST["sortKey"];
	}

	if (array_key_exists("sortOrder", $_REQUEST))
	{
		$sortOrder = $_REQUEST["sortOrder"];
	}
	
	Responder::GetHighScorePanel($sortKey, $sortOrder);
}
else if (!strcmp($_REQUEST["action"], "GetLogViewPanel"))
{
	if (array_key_exists("rowCount", $_REQUEST))
	{
		$rowCount = $_REQUEST["rowCount"];
	}

	Responder::GetLogViewPanel($rowCount);
}
else if (!strcmp($_REQUEST["action"], "GetEmbassyPanel"))
{
	Responder::GetEmbassyPanel();
}
else if (!strcmp($_REQUEST["action"], "GetAllianceTransferPanel"))
{
	Responder::GetAllianceTransferPanel();
}
else if (!strcmp($_REQUEST["action"], "GetGalaxyMap"))
{
	if (array_key_exists("shipId", $_REQUEST))
	{
		$shipId = $_REQUEST["shipId"];
	}

	if (array_key_exists("deliveryId", $_REQUEST))
	{
		$deliveryId = $_REQUEST["deliveryId"];
	}
	
	if (array_key_exists("targetSystemId", $_REQUEST))
	{
		$targetSystemId = $_REQUEST["targetSystemId"];
	}
	
	echo Responder::GetGalaxyMap($gamePlanSize, $shipId, $deliveryId, $targetSystemId);
}
else if (!strcmp($_REQUEST["action"], "DeliverDelivery"))
{
	if (array_key_exists("shipId", $_REQUEST))
	{
		$shipId = $_REQUEST["shipId"];
	}

	if (array_key_exists("deliveryId", $_REQUEST))
	{
		$deliveryId = $_REQUEST["deliveryId"];
	}
	
	if (array_key_exists("ignoreShipBusy", $_REQUEST))
	{
		$ignoreShipBusy = $_REQUEST["ignoreShipBusy"] == "true" ? true : false;
	}

	echo Responder::DeliverDelivery($shipId, $deliveryId, $ignoreShipBusy);
}
else if (!strcmp($_REQUEST["action"], "FinishDeliveries"))
{
	if (array_key_exists("shipId", $_REQUEST))
	{
		$shipId = $_REQUEST["shipId"];
	}

	echo Responder::FinishDeliveries($shipId);
}
else if (!strcmp($_REQUEST["action"], "BuyShip"))
{
	if (array_key_exists("modelId", $_REQUEST))
	{
		$modelId = $_REQUEST["modelId"];
	}

	if (array_key_exists("shipName", $_REQUEST))
	{
		$shipName = $_REQUEST["shipName"];
	}

	echo (Responder::BuyShip($modelId, $shipName) == NULL) ? 0 : 1;
}
else if (!strcmp($_REQUEST["action"], "CreateAlliance"))
{
	if (array_key_exists("allianceName", $_REQUEST))
	{
		$allianceName = $_REQUEST["allianceName"];
	}

	echo Responder::CreateAlliance($allianceName);
}
else if (!strcmp($_REQUEST["action"], "BuildBase"))
{
	if (array_key_exists("planetId", $_REQUEST))
	{
		$planetId = $_REQUEST["planetId"];
	}

	echo Responder::BuildBase($planetId);
}
else if (!strcmp($_REQUEST["action"], "InvitePlayerToAlliance"))
{
	if (array_key_exists("invitedLogin", $_REQUEST))
	{
		$invitedLogin = $_REQUEST["invitedLogin"];
	}

	echo Responder::InvitePlayerToAlliance($invitedLogin);
}
else if (!strcmp($_REQUEST["action"], "AnswerAllianceInvitations"))
{
	if (array_key_exists("invitationId", $_REQUEST))
	{
		$invitationId = $_REQUEST["invitationId"];
	}
	
	if (array_key_exists("accept", $_REQUEST))
	{
		$accept = $_REQUEST["accept"];
	}

	echo Responder::AnswerAllianceInvitations($invitationId, $accept);
}
else if (!strcmp($_REQUEST["action"], "LeaveAlliance"))
{
	echo Responder::LeaveAlliance();
}
else if (!strcmp($_REQUEST["action"], "KickAllianceMember"))
{
	if (array_key_exists("memberId", $_REQUEST))
	{
		$memberId = $_REQUEST["memberId"];
	}
	
	if (array_key_exists("reason", $_REQUEST))
	{
		$reason = $_REQUEST["reason"];
	}
	
	echo Responder::KickAllianceMember($memberId, $reason);
}
else if (!strcmp($_REQUEST["action"], "AllianceDonateMoney"))
{
	if (array_key_exists("amount", $_REQUEST))
	{
		$amount = $_REQUEST["amount"];
	}
	
	if (array_key_exists("recieverLogin", $_REQUEST))
	{
		$recieverLogin = $_REQUEST["recieverLogin"];
	}
	
	echo Responder::AllianceDonateMoney($amount, $recieverLogin);
}
else if (!strcmp($_REQUEST["action"], "AllianceDonateGuards"))
{
	if (array_key_exists("amount", $_REQUEST))
	{
		$donates = $_REQUEST["donates"];
	}
	
	echo Responder::AllianceDonateGuards($donates);
}
else if (!strcmp($_REQUEST["action"], "BuyLicence"))
{
	echo Responder::BuyLicence();
}
else if (!strcmp($_REQUEST["action"], "BuyEmbassyLevel"))
{
	echo Responder::BuyEmbassyLevel();
} 
else if (!strcmp($_REQUEST["action"], "FlyShipToTarget"))
{
	if (array_key_exists("targetType", $_REQUEST))
	{
		$targetType = $_REQUEST["targetType"];
	}
	
	if (array_key_exists("shipId", $_REQUEST))
	{
		$shipId = $_REQUEST["shipId"];
	}
	
	if (array_key_exists("targetId", $_REQUEST))
	{
		$targetId = $_REQUEST["targetId"];
	}

	echo Responder::FlyShipToTarget($targetType, $shipId, $targetId);
}
else if (!strcmp($_REQUEST["action"], "NavigateShip"))
{
	if (array_key_exists("shipId", $_REQUEST))
	{
		$shipId = $_REQUEST["shipId"];
	}
	
	if (array_key_exists("pathA", $_REQUEST))
	{
		$pathA = $_REQUEST["pathA"];
	}

	echo Responder::NavigateShip($shipId, $pathA);
}
else if (!strcmp($_REQUEST["action"], "BuyShipLevel"))
{
	if (array_key_exists("shipId", $_REQUEST))
	{
		$shipLevel = $_REQUEST["shipId"];
	}

	echo Responder::BuyShipLevel($shipLevel);
}
else if (!strcmp($_REQUEST["action"], "ApplyGuardAssignments"))
{
	if (array_key_exists("assignments", $_REQUEST))
	{
		$assignments = $_REQUEST["assignments"];
	}

	echo Responder::ApplyGuardAssignments($assignments);
}
else if (!strcmp($_REQUEST["action"], "GetMessagePanel"))
{
	if (array_key_exists("mode", $_REQUEST))
	{
		$mode = $_REQUEST["mode"];
	}
	
	if (array_key_exists("messageId", $_REQUEST))
	{
		$messageId = $_REQUEST["messageId"];
	}
	
	if (array_key_exists("sortKey", $_REQUEST))
	{
		$sortKey = $_REQUEST["sortKey"];
	}

	if (array_key_exists("sortOrder", $_REQUEST))
	{
		$sortOrder = $_REQUEST["sortOrder"];
	}
	
	if (array_key_exists("reciever", $_REQUEST))
	{
		$reciever = $_REQUEST["reciever"];
	}

	Responder::GetMessagePanel($messageId, $mode, $sortKey, $sortOrder, $reciever);
}
else if (!strcmp($_REQUEST["action"], "SendNewMessage"))
{
	if (array_key_exists("reciever", $_REQUEST))
	{
		$reciever = $_REQUEST["reciever"];
	}
	
	if (array_key_exists("subject", $_REQUEST))
	{
		$subject = $_REQUEST["subject"];
	}
	
	if (array_key_exists("textbody", $_REQUEST))
	{
		$textBody = $_REQUEST["textbody"];
	}

	Responder::SendNewMessage($reciever, $subject, $textBody);
}
else if (!strcmp($_REQUEST["action"], "DeleteMessage"))
{
	if (array_key_exists("messageId", $_REQUEST))
	{
		$messageId = $_REQUEST["messageId"];
	}

	Responder::DeleteMessage($messageId);
}
else if (!strcmp($_REQUEST["action"], "logout"))
{
	Responder::Logout();
}
else
{
	echo "Invalid action.";
}

$dbManager = DBManager::GetInstance();
$dbManager->Dispose();
?>